{
Copyright 2006-2007 John T. Haller of PortableApps.com

Website: http://PortableApps.com/

This software is OSI Certified Open Source Software.
OSI Certified is a certification mark of the Open Source Initiative.

Please see the included license file for the full details on
all included components.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Modified July 8, 2007 by Karl McMurdo (XrXca) to allow dragging the
menu on screen.

}

unit main;

interface

uses Windows, Classes, Forms, StdCtrls, Buttons, ExtCtrls, ComCtrls,
  Jpeg, ShellAPI, Controls, Graphics, Dialogs, SysUtils, INIFiles,
  about, StrUtils, Menus, add_app, Messages, Registry, TypInfo;

type
  TfrmMenu = class(TForm)

    // === BRANDING ===
    // PortableApps.com logo split into icons to use alpha transparency
    // smaller size used for compatibility with older Windows versions
    // ... part of the upcoming theming system
    imgPortableAppsLogo1: TImage;
    imgPortableAppsLogo2: TImage;
    imgPortableAppsLogo3: TImage;
    imgPortableAppsLogo4: TImage;
    imgPortableAppsLogo5: TImage;
    imgPortableAppsLogo6: TImage;

    // Alternate logo for Windows versions that don't support alpha icons
    imgPortableAppsLogoPixel: TImage;

    // === THEMING ===
    // Only a portion of the upcoming theming engine is contained here
    imgBackground: TImage;
    imgClose: TImage; // not yet used visibly but used as a clickable element
    imgDriveSpace: TImage;

    // === INTERFACE ===
    // Application icons
    sbtnApplication1: TSpeedButton;
    sbtnApplication2: TSpeedButton;
    sbtnApplication3: TSpeedButton;
    sbtnApplication4: TSpeedButton;
    sbtnApplication5: TSpeedButton;
    sbtnApplication6: TSpeedButton;
    sbtnApplication7: TSpeedButton;
    sbtnApplication8: TSpeedButton;
    sbtnApplication9: TSpeedButton;
    sbtnApplication10: TSpeedButton;
    sbtnApplication11: TSpeedButton;
    sbtnApplication12: TSpeedButton;
    sbtnApplication13: TSpeedButton;
    sbtnApplication14: TSpeedButton;
    sbtnApplication15: TSpeedButton;
    sbtnApplication16: TSpeedButton;
    sbtnApplication17: TSpeedButton;
    sbtnApplication18: TSpeedButton;
    sbtnApplication19: TSpeedButton;
    sbtnApplication20: TSpeedButton;

    // Scroll buttons for the application icons
    sbtnScrollUp: TSpeedButton;
    sbtnScrollDown: TSpeedButton;

    // Folder and function icons split into buttons and images
    sbtnDocuments: TSpeedButton;
    imgDocuments: TImage;

    sbtnMusic: TSpeedButton;
    imgMusic: TImage;

    sbtnPictures: TSpeedButton;
    imgPictures: TImage;

    sbtnVideo: TSpeedButton;
    imgVideo: TImage;

    sbtnExplore: TSpeedButton;
    imgExplore: TImage;

    imgDivider1: TImage;

    sbtnBackup: TSpeedButton;
    imgBackup: TImage;

    sbtnOptions: TSpeedButton;
    imgOptions: TImage;

    imgDivider2: TImage;
    sbtnSearch: TSpeedButton;
    imgSearch: TImage;

    sbtnHelp: TSpeedButton;
    imgHelp: TImage;

    // Drive name and free space display
    lblDriveName: TLabel;
    lblDriveSpace: TLabel;

    // === POPUP MENUS ===
    pmnuBackup: TPopupMenu;
    pmnuitmBackup: TMenuItem;
    pmnuitmRestore: TMenuItem;

    pmnuOptions: TPopupMenu;
    pmnuitmOptionsSmallFonts: TMenuItem;
    pmnuitmOptionsLargeFonts: TMenuItem;
    pmnuitmOptionsDivider2: TMenuItem;
    pmnuitmOptionsAddApp: TMenuItem;
    pmnuitmOptionsRemoveApp: TMenuItem;
    pmnuitmOptionsGetMore: TMenuItem;
    pmnuitmOptionsRefreshApps: TMenuItem;

    pmnuSearch: TPopupMenu;
    pmnuitmSearchDrive: TMenuItem;
    pmnuitmSearchComputer: TMenuItem;
    pmnuitmSearchWeb: TMenuItem;

    // === TRAY ICON ===
    trayiconMenu: TTrayIcon;

    // === TIMERS ===
    tmrFader: TTimer;
    tmrWatchFocus: TTimer;
    pmnuitmOptionsDivider3: TMenuItem;
    pmnuitmOptionsStayVisible: TMenuItem;
    pmnuitmOptionsDivider0: TMenuItem;
    pmnuitmOptionsLocale: TMenuItem;
    pmnuitmOptionsTheme: TMenuItem;
    pmnuPafData: TPopupMenu;
    pmnuitmPafDataHideApp: TMenuItem;
    pmnuitmPafDataAutoRunApp: TMenuItem;
    pmnuitmPafDataRenameApp: TMenuItem;
    pmnuitmOptionsDivider1: TMenuItem;
    pmnuitmOptionsUnhideApps: TMenuItem;
    pmnuPafDataDivider0: TMenuItem;
    pmnuitmPafDataExecOnClose: TMenuItem;
    pmnuCustButtons: TPopupMenu;
    pmnuitmCustButtonsRename: TMenuItem;
    pmnuitmCustButtonsChange: TMenuItem;
    pmnuitmOptionsDivider4: TMenuItem;
    pmnuitmOptionsExit: TMenuItem;
    pmnuitmOptionsDisableFade: TMenuItem;
    pmnuitmOptionsLoadFromDB: TMenuItem;
    pmnuitmOptionsLoadWallpaper: TMenuItem;
    pmnuitmOptionsShowHideMenu: TMenuItem;
    pmnuitmOptionsRestorePosition: TMenuItem;
    pmnuitmOptionsSnapToScreen: TMenuItem;

    // === PROCEDURES ===
    // standard form handlers
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    // Special handlers for clicks of app icons
    procedure AppButtonClick(Sender: TObject);
    procedure AppButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    // Scrolling the app icon list up or down
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure sbtnScrollUpClick(Sender: TObject);
    procedure sbtnScrollDownClick(Sender: TObject);
    procedure ScrollApps(bolScrollUp: Boolean);

    // Handlers for the folder and function buttons
    procedure sbtnDocumentsClick(Sender: TObject);
    procedure sbtnMusicClick(Sender: TObject);
    procedure sbtnPicturesClick(Sender: TObject);
    procedure sbtnVideoClick(Sender: TObject);
    procedure sbtnExploreClick(Sender: TObject);
    procedure sbtnBackupClick(Sender: TObject);
    procedure sbtnOptionsClick(Sender: TObject);
    procedure sbtnHelpClick(Sender: TObject);
    procedure sbtnSearchClick(Sender: TObject);
    procedure imgCloseClick(Sender: TObject);

    // Tray icon handler
    procedure trayiconMenuClick(Sender: TObject);

    // Display / hide the menu, fade in/out
    procedure FadeInOut(bolFadeInNow: Boolean);
    procedure tmrWatchFocusTimer(Sender: TObject);
    procedure tmrFaderTimer(Sender: TObject);

    // Popup menu handlers
    // Backup popup menu
    procedure pmnuitmBackupClick(Sender: TObject);
    procedure pmnuitmRestoreClick(Sender: TObject);

    // Options popup menu
    procedure pmnuOptionsPopup(Sender: TObject);
    procedure pmnuitmOptionsSmallFontsClick(Sender: TObject);
    procedure pmnuitmOptionsLargeFontsClick(Sender: TObject);
    procedure pmnuitmLocaleClick(Sender: TObject);
    procedure pmnuitmThemeClick(Sender: TObject);
    procedure pmnuitmOptionsAddAppClick(Sender: TObject);
    procedure pmnuitmOptionsRemoveAppClick(Sender: TObject);
    procedure pmnuitmOptionsRefreshAppsClick(Sender: TObject);
    procedure pmnuitmOptionsGetMoreClick(Sender: TObject);
    procedure pmnuitmOptionsStayVisibleClick(Sender: TObject);
    procedure pmnuitmOptionsUnhideAppsClick(Sender: TObject);
    procedure pmnuitmOptionsLoadFromDBClick(Sender: TObject);
    procedure pmnuitmOptionsLoadWallpaperClick(Sender: TObject);
    procedure pmnuitmOptionsRestorePositionClick(Sender: TObject);  // (XrXca)

    // Help popup menu
    procedure pmnuitmSearchWebClick(Sender: TObject);
    procedure pmnuitmSearchComputerClick(Sender: TObject);
    procedure pmnuitmSearchDriveClick(Sender: TObject);

    // App PafData popup menu
    procedure pmnuitmPafDataHideAppClick(Sender: TObject);
    procedure pmnuitmPafDataRenameAppClick(Sender: TObject);
    procedure pmnuitmPafDataAutoRunAppClick(Sender: TObject);
    procedure pmnuitmPafDataExecOnCloseClick(Sender: TObject);

    // Customizable buttons popup menu
    procedure SpeedButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pmnuitmCustButtonsChangeClick(Sender: TObject);
    procedure pmnuitmCustButtonsRenameClick(Sender: TObject);

    // Setting save and restore functions
    function GetStoredVariable(strVariable: String; strDefault: String) : String;
    function GetStoredSection(strSection: String) : TStringList;
    procedure SetStoredVariable(strVariable: String; strSetting: String);
    procedure SetStoredSection(strSection: String; tstrlstContents: TStringList);

    // Locale and Theme Loaders
    procedure LoadLocale();
    procedure LoadTheme();

    // Handle global hot-key
    procedure WMHotkey(var msg: TWMHotkey); message WM_HOTKEY;
    procedure pmnuitmOptionsDisableFadeClick(Sender: TObject);

    // Wallpaper functions
    function GetWallpaper() : String;
    function GetWallpaperStyle() : String;
    function GetTileWallpaper() : String;
    procedure SetWallpaper(strFilename, strWallpaperStyle, strTileWallpaper: String);
    procedure pmnuitmOptionsShowHideMenuClick(Sender: TObject);

    // Dynamic image generic click handler
    procedure dynimgCustomImageClick(Sender: TObject);

    // Menu Dragging Procedures (XrXca)
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnFormMoving(var Msg: TWMMoving); message WM_MOVING;
    procedure ApplyThemeOffsets;

    // Handle Screens Size Changing
    procedure OnDisplayChange(var Message: TMessage); message WM_DISPLAYCHANGE;
    procedure pmnuitmOptionsSnapToScreenClick(Sender: TObject);

  protected
    // Used to add a drop shadow to the menu
    procedure CreateParams(var Params: TCreateParams); override;

  private
    // array of application names and EXE paths for the icons
    tstrlstApplications: TStringList;

    // object array of app buttons, corresponds to tstrlstApplications
//    arrAppButtons: array [0..19] of TSpeedButton;
    arrAppButtons: array of TSpeedButton;

    // object array of app icons, corresponds to arrAppButtons
    arrAppIcons: array of HICON;

    // tracking variable for the currently displayer first icon
    intFirstButton: integer;

    // tracking variables for the fade timers
    bolFadeIn: boolean; // true if fading in
    bolFadeToExit: boolean; // true if exiting on fade out

    // container variables for drive size, free space size and name
    dblDriveSize: double;
    strDriveSize: string;
    dblDriveFree: double;
    dblDriveUsed: double;
    strDriveFree: string;
    strDriveName: string;

    // tracking variables for permanent visbility support
    bolVisible: Boolean;
    bolFirstRefresh: Boolean;

    // Disable Fade tracking variable
    bolDisableFade: Boolean;

    // Tracking variable for 'LoadAppsFromDB' feature
    bolLoadAppsFromDB: Boolean;

    // Theme & locale name variables
    strTheme: String;
    strIconTheme: String;
    strLocale: String;
    strLocaleVersion: String;

    // Theme-related tracking variables
    bolSwitchSide: Boolean;
    intOffsetX: Integer;
    intOffsetY: Integer;
    intAppOffsetX: Integer;
    intAppOffsetY: Integer;
    intDefaultOffsetX: Integer; // (XrXca)
    intDefaultOffsetY: Integer; // (XrXca)
    colAppTransparentColor: TColor;
    fntAppFont: TFont;
    bolForcePixel: Boolean;
    bolForceAlpha: Boolean;
    picOriginalLogo: TPicture;
    imgarrCustomImages: Array of TImage;
    bolSeperateAppArrows: Boolean;

    // Customizable Button menu tracker
    objButtonClicked: TObject;

    // 'CD' mode tracking variable
    bolIsLive: Boolean;

    // Right-click event tracking variable, to simplify coding
    strPafData: String;

    // Localization strings
    strInstallMessage: String;
    strAppInstallFailed: String;
    strAppRemoveMessage: String;
    strAppRenameMessage: String;
    strRegisterHotkeyError: String;
    strAppInstallButtonOK: String;
    strAppInstallButtonCancel: String;
    strRenameButtonCaption: String;
    strRenameButtonPrompt: String;
    strChangeButtonCaption: String;
    strChangeButtonPrompt: String;
    strHelpDialog: String;
    strFreeOf: String;

    // Theme-related Error Messages
    strDefaultThemeCorrupted: String;
    strSelectedThemeCorrupted: String;

    // Wallpaper changer-related strings
    bolLoadWallpaper: Boolean;
    strOriginalWallpaper: String;
    strOriginalWallpaperStyle: String;
    strOriginalWallpaperTiled: String; 

    // Internal procedures to handle the buttons, menus and font size
    procedure ChangeMenuFontSize(intFontSize: integer);
    procedure InitButtons(intListLength: Integer);
    procedure SetupButtonsFromDB();
    procedure SetupButtons();
    procedure DisplayButtons();
    procedure ClearButtons();
    procedure SetupMenus();

    // Procedure to handle our 'multiple-instance-opened' message
    function WindowsMessageRecieved(var Msg : TMessage) : Boolean;

    // Function to return offset integers reflecting percentage values
    function OffsetToInt(strInteger : String; intDenominator : Integer) : Integer;

  public
    // public variable for the add app function to pass in the app to install
    strAppToInstall: string;
  published
end;
  TMenuItemExtended = class(TMenuItem)
  private
    fValue: string;
  published
    property Value : string read fValue write fValue;
end;
  TProcedure = procedure of Object;

var
  frmMenu: TfrmMenu;

implementation

{$R *.dfm}

//resourcestring

procedure TfrmMenu.CreateParams(var Params: TCreateParams);
// used to display a drop shadow on the menu on WinXP and up
const
  CS_DROPSHADOW = $00020000;
begin
  inherited;
  if (Win32MajorVersion >= 5) and (Win32MinorVersion >= 1)
            AND (Win32Platform = VER_PLATFORM_WIN32_NT) then
    Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

// =====================================

function TFrmMenu.WindowsMessageRecieved(var Msg : TMessage) : Boolean;
// Handle our custom 'multiple-instance' event
begin
  if Msg.Msg = RegisterWindowMessage(PAnsiChar('IWishMyPortableAppsMenuWouldReappearOnA_NewInstanceCalled'+ParamStr(0))) then
  begin
    FadeInOut(true);
    result := true;
  end
  else
    result := false;
end;

// =====================================

procedure TfrmMenu.OnDisplayChange(var Message: TMessage);
// Handle Changes to Screen Resolution
begin
  ApplyThemeOffsets;
  If frmMenu.Visible then
    FadeInOut(true);
end;

// =====================================

procedure TFrmMenu.WMHotkey(var msg: TWMHotkey);
// Shift-Win hotkey handler
begin
  // Hide window if visible, show if not
  if frmMenu.Visible then
    FadeInOut(false)
  else
    FadeInOut(true);
end;

// =====================================

procedure TFrmMenu.FormCreate(Sender: TObject);
begin
  // Insert our message handler
  Application.HookMainWindow(WindowsMessageRecieved);
  // Default Button State
  intFirstButton:=0;

  imgPortableAppsLogoPixel.Picture.Bitmap.TransparentColor:=clFuchsia;
  picOriginalLogo:=imgPortableAppsLogoPixel.Picture;

  // Create the window hidden and set its properties
  ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE,
    GetWindowLong(Application.Handle, GWL_EXSTYLE)
    or WS_EX_TOOLWINDOW );

  // Check to see if our EXE is set to read-only, if so set to 'CD' mode
  // Also, this isn't cross-platform, but it shouldn't be hard to drop in a replacement
  if FileGetAttr(ParamStr(0)) and faReadOnly > 0 then
    bolIsLive:=True
  else
    bolIsLive:=False;

  // Check if 'LoadAppsFromDB' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('LoadAppsFromDB', 'false'))='true' then
    bolLoadAppsFromDB:=True;
  pmnuitmOptionsLoadFromDB.Checked:=bolLoadAppsFromDB;

  // Check if wallpaper swapping is enabled
  if ansiLowerCase(GetStoredVariable('LoadWallpaper', 'true'))<>'false' then
  begin
    bolLoadWallpaper:=True;
    pmnuitmOptionsLoadWallpaper.Checked:=True;
  end;

  // Get locale & theme filenames
  strLocale:=GetStoredVariable('Locale', 'English-US.locale');
  strTheme:=GetStoredVariable('Theme', 'default');

  // Setup the app list/menus
  bolFirstRefresh:=true;
  if bolLoadAppsFromDB then
    SetupButtonsFromDB
  else
    SetupButtons;
  SetupMenus;

  //Get the original Wallpaper and WallpaperStyle and set up the new one (if avaliable)
  strOriginalWallpaper:='';
  strOriginalWallpaper:=GetWallpaper();
  strOriginalWallpaperStyle:=GetWallpaperStyle();
  strOriginalWallpaperTiled:=GetTileWallpaper();

  // Load Offsets for Moved Menu
  intOffsetX := StrToIntDef(GetStoredVariable('OffsetX','65000'), 65000);
  intOffsetY := StrToIntDef(GetStoredVariable('OffsetY','65000'), 65000);

  // Load Locale & Theme
  LoadLocale();
  LoadTheme();

  // Register 'show/hide' hotkey. Needs the redundant MOD_SHIFT for some unknown reason
  if not RegisterHotkey(Handle, 1, MOD_WIN or MOD_SHIFT, VK_SHIFT)
     or not RegisterHotkey(Handle, 2, MOD_SHIFT, VK_F11) then
    showmessage(strRegisterHotkeyError);

  // Display the window
  ShowWindow(Application.Handle, SW_SHOW);

  // Check if 'SnapToScreen' is set to true in the configuration file
  pmnuitmOptionsSnapToScreen.Checked := (ansiLowerCase(GetStoredVariable('SnapToScreen', 'false'))<>'false');
  frmMenu.ScreenSnap := pmnuitmOptionsSnapToScreen.Checked;

  // Check if 'DisableFade' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('DisableFade', 'false'))<>'false' then
    bolDisableFade:=True;
  pmnuitmOptionsDisableFade.Checked:=bolDisableFade;

  // Check if 'StartMinimized' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('StartMinimized', 'false'))<>'false' then
    FadeInOut(false)
  else
    FadeInOut(true);
  bolFadeToExit:=false;
  // Check if 'LargeFonts' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('LargeFonts', 'false'))<>'true' then begin
    pmnuitmOptionsSmallFonts.Checked:=true;
    ChangeMenuFontSize(8);
  end
  else begin
    pmnuitmOptionsLargeFonts.Checked:=true;
    ChangeMenuFontSize(10);
  end;
  // Check if 'StayVisible' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('StayVisible', 'false'))='true' then begin
    pmnuitmOptionsStayVisible.Checked:=true;
    bolVisible:=true;
    // Bring to top of all windows, 'Always On Top'
    SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end;
end;

// =====================================

procedure TfrmMenu.FormDestroy(Sender: TObject);
var
  lstExecOnClose: TStringList;
  intCounter: Integer;
begin
  // Unregister our Global Hotkeys
  UnregisterHotkey(Handle, 1);
  UnregisterHotkey(Handle, 2);
  // Unhook our message handler
  Application.UnHookMainWindow(WindowsMessageRecieved);

  //Reset the original Wallpaper and WallpaperStyle (if needed)
  if strOriginalWallpaper<>'' then
  begin
    SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
  end;

  // Run ExecOnClose apps
  lstExecOnClose:=GetStoredSection('ExecOnClose');
  for intCounter := 0 to lstExecOnClose.Count-1 do
    ShellExecute(0,'open', PAnsiChar(ExtractFileDrive(ParamStr(0))+lstExecOnClose.ValueFromIndex[intCounter]),Nil, Nil, SW_SHOW);
  lstExecOnClose.Free;

  // Run old ExecOnClose batch file
  ShellExecute(0,'open', PAnsiChar(GetStoredVariable('ExecOnClose', 'ExecOnClose.bat')),Nil, Nil, SW_SHOW);

  // Quit now and skip saving settings if we're running from CD
  if bolIsLive then
    exit;
  // Save our settings
  SetStoredVariable('LargeFonts', BoolToStr(pmnuitmOptionsLargeFonts.Checked, True));
  SetStoredVariable('StayVisible', BoolToStr(pmnuitmOptionsStayVisible.Checked, True));
  SetStoredVariable('Theme', strTheme);
  SetStoredVariable('Locale', strLocale);
  SetStoredVariable('DisableFade', BoolToStr(bolDisableFade, True));
  SetStoredVariable('LoadAppsFromDB', BoolToStr(bolLoadAppsFromDB, True));
  SetStoredVariable('LoadWallpaper', BoolToStr(bolLoadWallpaper, True));
  SetStoredVariable('OffsetX', IntToStr(intOffsetX));
  SetStoredVariable('OffsetY', IntToStr(intOffsetY));
  SetStoredVariable('SnapToScreen', BoolToStr(pmnuitmOptionsSnapToScreen.Checked, True));
  if bolLoadAppsFromDB then
    SetStoredSection('AppDB', tstrlstApplications);
end;

// =====================================

procedure TfrmMenu.FormActivate(Sender: TObject);
  var
    iniAutorun: TINIFile;
    strAutorunFilename: string;
begin
  // Position our menu at the bottom right
  // **TODO - Add ability to disable shadow and reposition menu in corner
  if bolSwitchSide then
  begin
    Left:=0+intOffsetX;
    Top:=0+intOffsetY;
  end
  else
  begin
    Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
    Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
  end;

  // Get the drive's name from the autorun.inf
  strAutorunFilename:= Trim(ExtractFileDrive(ParamStr(0)) + '\autorun.inf');
  iniAutorun:=TINIFile.Create(strAutorunFilename);
  strDriveName := iniAutorun.ReadString('Autorun', 'Label', 'Drive');
  iniAutorun.Free;
  lblDriveName.Caption:=strDriveName + ' (' + ExtractFileDrive(ParamStr(0)) + ')';
end;

// =====================================

procedure TfrmMenu.AppButtonClick(Sender: TObject);
// Special handler for the app button clicks
var
  iControl : integer;
begin
  for iControl := 0 to length(arrAppButtons) do
  begin
    if TObject(arrAppButtons[iControl]) = Sender then
    begin
      // execute the exe path that corresponds to the same index in the app array
      ShellExecute(0,'open', PAnsiChar(tstrlstApplications.ValueFromIndex[iControl+intFirstButton]+#0),Nil, Nil, SW_SHOW);
    end;
  end;
end;

// =====================================

procedure TfrmMenu.AppButtonMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iControl: integer;
  iniPafData: TINIFile;
  iniSettings: TINIFile;
begin
  // Don't load the right-click menu if we're on a CD
  if bolIsLive then
    exit;
  // If it's the right mouse button that's been clicked
  if Button = mbRight then
  begin
  for iControl := 0 to length(arrAppButtons) do
  begin
    if TObject(arrAppButtons[iControl]) = Sender then
    begin
      // A long line of code to set the pafdata location
      strPafData:=PAnsiChar(ChangeFileExt(tstrlstApplications.ValueFromIndex[iControl+intFirstButton], '.pafdata'));
      // Load the existing paf-data stuff
      iniPafData:=TINIFile.Create(strPafData);
      if ansiLowerCase(iniPafData.ReadString('PAFDATA', 'Autoexec', 'False'))='true' then
        pmnuitmPafDataAutoRunApp.Checked:=True
      else
        pmnuitmPafDataAutoRunApp.Checked:=False;

      if ansiLowerCase(iniPafData.ReadString('PAFDATA', 'Visible', 'True'))='false' then
        pmnuitmPafDataHideApp.Checked:=True
      else
        pmnuitmPafDataHideApp.Checked:=False;

      iniPafData.Free;

      // Load the ExecOnClose settings
      iniSettings:=TINIFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
      if iniSettings.ReadString('ExecOnClose', ExtractFileName(strPafData), 'none')<>'none' then
        pmnuitmPafdataExecOnClose.Checked:=True
      else
        pmnuitmPafdataExecOnClose.Checked:=False;

      // Make sure our file exists and if it does that it isn't readonly
      if (FileGetAttr(strPafData) and faReadOnly = 0) or (FileExists(strPafData)<>True) then
        pmnuPafData.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
    end;
  end;
  end;
end;

procedure TfrmMenu.ApplyThemeOffsets;
var
  rctMonitor: TRect;
  rctWin: TRect;
  ptPoint: TPoint;
begin
  if ( intOffsetX > 60000 )  then
  begin
    IntOffSetX := intDefaultOffsetX;
    IntOffSetY := intDefaultOffsetY;
    Exit;
  end;
  // Translate
  if not bolSwitchSide then
  begin
    IntOffSetX := IntOffSetX + Screen.WorkAreaWidth - Width;
    intOffsetY := intOffSetY + Screen.WorkAreaHeight - Height;
  end;
  rctWin.Left:= intOffsetX;
  rctWin.Top:= intOffsetY;
  rctWin.Right := intOffsetX + Width;
  rctWin.Bottom := intOffsetY + Height;
  ptPoint.X := intOffsetX + Width div 2;
  ptPoint.Y := intOffsetY + Height div 2;
  rctMonitor := Screen.MonitorFromPoint(ptPoint).WorkareaRect;
  if rctWin.Left < rctMonitor.Left then
    intOffSetX := rctMonitor.Left;
  if rctWin.Top < rctMonitor.Top then
    intOffSetY := rctMonitor.Top;
  if ( rctWin.Right > rctMonitor.Right ) then
    intOffsetX := rctMonitor.Right - Width;
  if rctWin.Bottom > rctMonitor.Bottom then
    intOffSetY := rctMonitor.Bottom - Height;
  if not bolSwitchSide then
  begin
    IntOffSetX := IntOffSetX - Screen.WorkAreaWidth + Width;
    intOffsetY := intOffSetY - Screen.WorkAreaHeight + Height;
  end;
end;

// =====================================

procedure TfrmMenu.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
// scroll the menu up when the user scrolls the mouse wheel up over the form
begin
  ScrollApps(true);
end;

// =====================================

procedure TfrmMenu.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// MouseDown Procedure to enable dragging form (XrXca)
begin
   ReleaseCapture;
   SendMessage(frmMenu.Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
   // I've never quite figured out why the +2, but it works better than without it (XrXca)
end;

// =====================================

procedure TfrmMenu.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
// scroll the menu down when the user scrolls the mouse wheel down over the form
begin
  ScrollApps(false);
end;

// =====================================

procedure TfrmMenu.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
// catch presses of the up or down arrow as an alternative means of scrolling
begin
  if HiWord(GetKeyState(VK_UP)) <> 0 then
    ScrollApps(true)
  else
    if HiWord(GetKeyState(VK_DOWN)) <> 0 then
      ScrollApps(false)
  else
    if HiWord(GetKeyState($58)) <> 0 then
    begin
      bolVisible:=false;
      bolFadeToExit:=true;
      FadeInOut(false);
    end;
end;

// =====================================

procedure TfrmMenu.sbtnScrollUpClick(Sender: TObject);
begin
  ScrollApps(true);
end;

// =====================================

procedure TfrmMenu.sbtnScrollDownClick(Sender: TObject);
begin
  ScrollApps(false);
end;

// =====================================

procedure TfrmMenu.ScrollApps(bolScrollUp: Boolean);
// scroll the icon list
begin
  if bolScrollUp then
  begin
    if (intFirstButton > 0) and sbtnScrollUp.visible then
    begin
      intFirstButton:=intFirstButton-1;
      DisplayButtons();
    end
  end else begin
    if (intFirstButton < (tstrlstApplications.Count-length(arrAppButtons))) and sbtnScrollDown.visible then
    begin
      intFirstButton:=intFirstButton+1;
      DisplayButtons();
    end;
  end;
  if intFirstButton >= (tstrlstApplications.Count-length(arrAppButtons)) then
    sbtnScrollDown.Visible:=False
  else
    sbtnScrollDown.Visible:=True;
  if intFirstButton = 0 then
    sbtnScrollUp.Visible:=False
  else
    sbtnScrollUp.Visible:=True;
end;

// =====================================

procedure TfrmMenu.SpeedButtonMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Right click event handler for cust-buttons
begin
  // Don't load the right-click menu if we're on a CD
  if bolIsLive then
    exit;
  // If it's the right mouse button that's been clicked
  if Button = mbRight then
  begin
    objButtonClicked:=Sender;
    pmnuCustButtons.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
  end;
end;

// =====================================

procedure TfrmMenu.sbtnDocumentsClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Documents folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnDocuments.Name+'_PATH', '\Documents\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnMusicClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Music folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnMusic.Name+'_PATH', '\Documents\Music\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnPicturesClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Pictures folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnPictures.Name+'_PATH', '\Documents\Pictures\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnVideoClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Video folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnVideo.Name+'_PATH', '\Documents\Video\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnExploreClick(Sender: TObject);
// show Windows explorer (explorer mode) browsing to the root of the portable device
begin
  ShellExecute(0,'explore', PAnsiChar(ExtractFileDrive(ParamStr(0)) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnBackupClick(Sender: TObject);
// show the Backup popup menu
begin
  pmnuBackup.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

// =====================================

procedure TfrmMenu.sbtnOptionsClick(Sender: TObject);
// show the Options popup menu
begin
  // Tell the menu we're activating the menu from the options button
  pmnuOptions.Tag := 1;
  pmnuOptions.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
  pmnuOptions.Tag := 0;
end;

// =====================================

procedure TfrmMenu.sbtnHelpClick(Sender: TObject);
// show the Help popup menu
var
  lngFileInfoSize: Longint;
  dwdFileInfoLength: DWord;
  ptrFileInfo, ptrFileInfoLanguage, ptrFileInfoData: Pointer;
  uintFileInfoDataLength: Uint;
  strFileInfoQuery: String;
begin
  lngFileInfoSize:=GetFileVersionInfoSize(PChar(ParamStr(0)), dwdFileInfoLength);
  if (lngFileInfoSize > 0) then
  begin
    GetMem(ptrFileInfo, lngFileInfoSize);
    try
    // Check if the current app has a ProductName
    if GetFileVersionInfo(PChar(ParamStr(0)), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
    begin
      strFileInfoQuery:='ProductVersion';
      if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
        strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
      HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
      if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
        ShowMessageFmt(strHelpDialog, [strPas(ptrFileInfoData), strLocaleVersion]);
    end;
    finally
      FreeMem(ptrFileInfo, lngFileInfoSize);
    end;
  end;
end;

// =====================================

procedure TfrmMenu.sbtnSearchClick(Sender: TObject);
// show the search popup menu
begin
  pmnuSearch.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

// =====================================

procedure TfrmMenu.imgCloseClick(Sender: TObject);
// close the application
begin
  bolVisible:=false;
  bolFadeToExit:=true;
  FadeInOut(false);
end;

// =====================================

procedure TfrmMenu.trayiconMenuClick(Sender: TObject);
// show/hide the menu on a tray icon click
begin
  if frmMenu.Visible then begin
    FadeInOut(false);
  end else begin
    FadeInOut(true);
  end;
end;

// =====================================

procedure TfrmMenu.FadeInOut(bolFadeInNow: Boolean);
// fade the menu in or out and recalculate the drive size on a fade in
begin
  if (bolVisible=true) and (bolFadeInNow=false) then
  begin
    // Bring the menu to the foreground instead of fading in
    Application.BringToFront;
    exit;
  end;


  if bolFadeInNow then begin
    // position at the bottom right (or bottom left if side is switched) with space for the shadow
    if bolSwitchSide then
    begin
      Left:=0+intOffsetX;
      Top:=0+intOffsetY;
    end
    else
    begin
      Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
      Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
    end;

    // calculate and display the drive size
    dblDriveSize := DiskSize(Ord(ParamStr(0)[1]) - $40);
    if dblDriveSize > 1073741824 then
      strDriveSize := FloatToStrF((dblDriveSize/1073741824), ffFixed, 4, 0) + 'GB'
    else
      if dblDriveSize > 1048576 then
        strDriveSize := FloatToStrF((dblDriveSize/1048576), ffFixed, 4, 0) + 'MB'
      else
        if dblDriveSize > 1024 then
          strDriveSize := FloatToStrF((dblDriveSize/1024), ffFixed, 4, 0) + 'KB'
        else
          strDriveSize := FloatToStrF((dblDriveSize), ffFixed, 4, 0) + 'B';

    dblDriveFree := DiskFree(Ord(ParamStr(0)[1]) - $40);
    dblDriveUsed := dblDriveSize - dblDriveFree;

    if dblDriveFree > 1073741824 then
      strDriveFree := FloatToStrF((dblDriveFree/1073741824), ffFixed, 4, 1) + 'GB'
    else
      if dblDriveFree > 1048576 then
        strDriveFree := FloatToStrF((dblDriveFree/1048576), ffFixed, 4, 1) + 'MB'
      else
        if dblDriveUsed > 1024 then
          strDriveFree := FloatToStrF((dblDriveFree/1024), ffFixed, 4, 1) + 'KB'
        else
          strDriveFree := FloatToStrF((dblDriveFree), ffFixed, 4, 1) + 'B';

    lblDriveSpace.Caption:= strDriveFree + ' ' + strFreeOf + ' ' + strDriveSize;
    imgDriveSpace.Width:=round(dblDriveUsed/dblDriveSize*131);

    // set the appropriate hint
    trayiconMenu.Hint := 'Portable Apps Menu (Click to hide the menu)';

    // fade in now
    bolFadeIn:= True;
    tmrFader.Enabled:= True;
    frmMenu.Show;
    SetFocus;
    SetActiveWindow(Handle);
    SetForegroundWindow(Handle);
  end else begin // fade the menu out
    trayiconMenu.Hint := 'Portable Apps Menu (Click to show the menu)';
    bolFadeIn:= False;
    tmrFader.Enabled:= True;
  end;
end;

// =====================================

procedure TfrmMenu.tmrWatchFocusTimer(Sender: TObject);
begin
  if (getFocus() = 0) and (bolVisible = False) then FadeInOut(False);
end;

// =====================================

procedure TfrmMenu.tmrFaderTimer(Sender: TObject);
// adjust the alpha values to fade the menu in or out
begin
  if bolDisableFade then
  begin
    tmrFader.Enabled:= False;
    if BolFadeIn then
    begin
      frmMenu.AlphaBlendValue := 255;
    end
    else
    begin
      frmMenu.AlphaBlendValue := 0;
      frmMenu.Hide;
      if bolFadeToExit then // Exit the app on fade out if set to
      begin
        Close;
      end;
    end;
    exit;
  end;

  if bolFadeIn then
  begin
    if frmMenu.AlphaBlendValue < 225 then
    begin
      frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue + 30;
    end else begin
      frmMenu.AlphaBlendValue := 255;
      tmrFader.Enabled:= False;
    end;
  end else begin
    if frmMenu.AlphaBlendValue > 30 then
    begin
      frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue - 30;
    end else begin
      frmMenu.AlphaBlendValue := 0;
      frmMenu.Hide;
      tmrFader.Enabled:= False;
      if bolFadeToExit then // Exit the app on fade out if set to
      begin
        Close;
      end;
    end;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmBackupClick(Sender: TObject);
// Start PortableApps Backup
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\PortableAppsBackup\PortableAppsBackup.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmCustButtonsChangeClick(Sender: TObject);
var
  strName: String;
  strDefault: String;
begin
  strName:=TSpeedButton(objButtonClicked).Name;
  if strName='sbtnDocuments' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\')
  else if strName='sbtnMusic' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Music')
  else if strName='sbtnPictures' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Pictures')
  else if strName='sbtnVideo' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Video');
  SetStoredVariable(strName+'_PATH', InputBox(strChangeButtonCaption, strChangeButtonPrompt, strDefault));
end;

// =====================================

procedure TfrmMenu.pmnuitmCustButtonsRenameClick(Sender: TObject);
var
  strName: String;
  strDefault: String;
begin
  strName:=TSpeedButton(objButtonClicked).Name;
  strDefault:=TSpeedButton(objButtonClicked).Caption;
  SetStoredVariable(strName+'_NAME', InputBox(strRenameButtonCaption, strRenameButtonPrompt, strDefault));
  DisplayButtons;
end;

// =====================================

procedure TfrmMenu.pmnuitmRestoreClick(Sender: TObject);
// Start PortableApps Backup - Restore
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\PortableAppsBackup\PortableAppsBackupRestore.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsStayVisibleClick(Sender: TObject);
// Force the menu to stay visible
begin
  if pmnuitmOptionsStayVisible.Checked then begin
    pmnuitmOptionsStayVisible.Checked:=false;
    bolVisible:=false;
    // Bring to foreground, undo 'Always On Top'
    SetWindowPos(Handle, HWND_TOP, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end
  else begin
    pmnuitmOptionsStayVisible.Checked:=true;
    bolVisible:=true;
    // Bring to top of all windows, 'Always On Top'
    SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsUnhideAppsClick(Sender: TObject);
// Unhide all apps, just a really simple toggle & refresh here
begin
  if pmnuitmOptionsUnhideApps.Checked then
    pmnuitmOptionsUnhideApps.Checked:=False
  else
    pmnuitmOptionsUnhideApps.Checked:=True;

  intFirstButton:=0;
  ClearButtons();
  SetupButtons();
  DisplayButtons();
  SetupMenus();
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataAutoRunAppClick(Sender: TObject);
// Edit the paf-data file to autorun the app on startup
var
  iniPafData: TINIFile;
begin
  if bolIsLive then
    exit;
  iniPafData:=TINIFile.Create(strPafData);
  if AnsiLowerCase(iniPafData.ReadString('PAFDATA', 'Autoexec', 'False'))='true' then
    iniPafData.WriteString('PAFDATA', 'Autoexec', 'False')
  else
    iniPafData.WriteString('PAFDATA', 'Autoexec', 'True');

    intFirstButton:=0;
    ClearButtons();
    SetupButtons();
    DisplayButtons();
    SetupMenus();
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataExecOnCloseClick(Sender: TObject);
var
  iniSettings: TINIFile;
  strPathToApp: String;
begin
  iniSettings:=TINIFile.Create(ChangeFileExt(ParamStr(0), '.ini'));

  strPathToApp:=RightStr(ChangeFileExt(strPafData, '.exe'), Length(ChangeFileExt(strPafData, '.exe'))-2);
  if pmnuitmPafdataExecOnClose.Checked then
    iniSettings.DeleteKey('ExecOnClose', ExtractFileName(strPafData))
  else
    iniSettings.WriteString('ExecOnClose', ExtractFileName(strPafData), strPathToApp);
  iniSettings.UpdateFile;
  iniSettings.Free;
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataHideAppClick(Sender: TObject);
// Edit the paf-data file to hide the app
var
  iniPafData: TINIFile;
begin
  if bolIsLive then
    exit;
  iniPafData:=TINIFile.Create(strPafData);
  if AnsiLowerCase(iniPafData.ReadString('PAFDATA', 'Visible', 'true'))='true' then
    iniPafData.WriteString('PAFDATA', 'Visible', 'False')
  else
    iniPafData.WriteString('PAFDATA', 'Visible', 'True');

  intFirstButton:=0;
  ClearButtons();
  SetupButtons();
  DisplayButtons();
  SetupMenus();
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataRenameAppClick(Sender: TObject);
// Edit the paf-data file to rename the app
var
  iniPafData: TINIFile;
  strAppName: String;
begin
  if bolIsLive then
    exit;
  iniPafData:=TINIFile.Create(strPafData);
  strAppName:=InputBox(RightStr(pmnuitmPafDataRenameApp.Caption, Length(pmnuitmPafDataRenameApp.Caption)-1), strAppRenameMessage, '');
  if strAppName<>'' then
    iniPafData.WriteString('PAFDATA', 'Name', strAppName);

  intFirstButton:=0;
  ClearButtons();
  SetupButtons();
  DisplayButtons();
  SetupMenus();
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsShowHideMenuClick(Sender: TObject);
// Show/Hide the menu, regardless of bolVisible setting
var
  bolOriginalVisible: Boolean;
begin
  // Backup bolVisible and disable it
  bolOriginalVisible:=bolVisible;
  bolVisible:=False;
  // Hide if visible, else fade in
  if frmMenu.Visible then
    FadeInOut(false)
  else
    FadeInOut(true);
  // Restore bolVisible
  bolVisible:=bolOriginalVisible;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsSmallFontsClick(Sender: TObject);
// Switch to small fonts
begin
  pmnuitmOptionsSmallFonts.Checked:=true;
  ChangeMenuFontSize(8);
end;

procedure TfrmMenu.pmnuitmOptionsSnapToScreenClick(Sender: TObject);
begin
  pmnuitmOptionsSnapToScreen.Checked := not pmnuitmOptionsSnapToScreen.Checked;
  frmMenu.ScreenSnap := pmnuitmOptionsSnapToScreen.Checked;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsLargeFontsClick(Sender: TObject);
// Switch to large fonts
begin
  pmnuitmOptionsLargeFonts.Checked:=true;
  ChangeMenuFontSize(10);
end;

procedure TfrmMenu.pmnuitmOptionsLoadFromDBClick(Sender: TObject);
begin
  if not pmnuitmOptionsLoadFromDB.Checked then
  begin
    bolLoadAppsFromDB:=True;
    pmnuitmOptionsLoadFromDB.Checked:=True;
  end
  else
  begin
    bolLoadAppsFromDB:=False;
    pmnuitmOptionsLoadFromDB.Checked:=False;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsLoadWallpaperClick(Sender: TObject);
// Enable or disable the wallpaper swapper
begin
  // Set bolLoadWallpaper
  if not pmnuitmOptionsLoadWallpaper.Checked then
  begin
    bolLoadWallpaper := True;
    pmnuitmOptionsLoadWallpaper.Checked := True;
  end
  else
  begin
    bolLoadWallpaper := False;
    pmnuitmOptionsLoadWallpaper.Checked := False;
  end;

  // Reload wallpaper
  if bolLoadWallpaper then
  begin
    pmnuitmOptionsLoadWallpaper.Enabled := True;
    // If we have a wallpaper specifically set for this theme, use it, else use the global one
    if FileExists(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp', '2', '0')
    else if FileExists(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp', '2', '0')
    // For compatability with the original wallpaper-swapper, look in DefaultData too
    else if FileExists(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp', '2', '0')
    else
    begin
      SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
    end;
  end
  else
    SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsAddAppClick(Sender: TObject);
// Add an app
var
  strPortableAppsPath: string;
  procInstaller: TProcessInformation;
  startInstaller: TStartupInfo;
begin
  strAppToInstall:='';
  frmAddApp.lblAdd.Caption:=strInstallMessage;
  frmAddApp.btnInstall.Caption:=strAppInstallButtonOK;
  frmAddApp.btnCancel.Caption:=strAppInstallButtonCancel;
  frmAddApp.ShowModal;
  if strAppToInstall<>'' then
  begin
    if RightStr(strAppToInstall, 8)<>'.pat.exe' then
      strPortableAppsPath := ExtractFileDir(ExtractFileDir(ParamStr(0)))+'\'
    else
      strPortableAppsPath := ExtractFileDir(ParamStr(0))+'\Data\Theme\';

    FillChar(procInstaller, sizeof(TProcessInformation), 0);
    FillChar(startInstaller, sizeof(TStartupInfo), 0);
    startInstaller.cb := sizeof(TStartupInfo);

    if CreateProcess(nil, PAnsiChar('"' + strAppToInstall + '" -o"' + strPortableAppsPath + '" -y -/SILENT=YES /DESTINATION="' + strPortableAppsPath+'"'+#0), nil,
      nil, false, NORMAL_PRIORITY_CLASS, nil, nil,
      startInstaller, procInstaller) <> False then
    begin
      WaitForSingleObject(procInstaller.hProcess, INFINITE);
      CloseHandle(procInstaller.hThread);
      CloseHandle(procInstaller.hProcess);
    end
    else
      ShowMessageFmt(strAppInstallFailed, [strAppToInstall]);

    // Install done, refresh icons
    strAppToInstall:='';
    intFirstButton:=0;
    ClearButtons();
    SetupButtons();
    DisplayButtons();
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsDisableFadeClick(Sender: TObject);
// Disable fade effect
begin
  if not TMenuItem(Sender).Checked then
  begin
    bolDisableFade:=True;
    TMenuItem(Sender).Checked:=True;
  end
  else
  begin
    bolDisableFade:=False;
    TMenuItem(Sender).Checked:=False;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsRemoveAppClick(Sender: TObject);
// Remove an app - placeholder for actual procedure
begin
  ShowMessage(strAppRemoveMessage);
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================
procedure TfrmMenu.pmnuitmOptionsRestorePositionClick(Sender: TObject);
// Restore Default Position (And Show Menu) (XrXca)
begin
  intOffsetX := intDefaultOffsetX;
  intOffsetY := intDefaultOffsetY;
  if bolSwitchSide then
  begin
    Left:=0+intOffsetX;
    Top:=0+intOffsetY;
  end
  else
  begin
    Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
    Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
  end;
  if not frmMenu.Visible then
    FadeInOut(true);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsRefreshAppsClick(Sender: TObject);
// Refresh apps list
begin
    intFirstButton:=0;
    ClearButtons();
    SetupButtons();
    DisplayButtons();
    SetupMenus();
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsGetMoreClick(Sender: TObject);
// Get more applications
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\FirefoxPortable\FirefoxPortable.exe'), 'http://portableapps.com/apps', Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchDriveClick(Sender: TObject);
// Open windows search for this drive
begin
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(ParamStr(0)) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchComputerClick(Sender: TObject);
// Open windows search for the drive containing the WINDIR
var
  strWinDir: string;
begin
  strWinDir := GetEnvironmentVariable('WINDIR');
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(strWinDir) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchWebClick(Sender: TObject);
// Open a web search in Firefox Portable
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\FirefoxPortable\FirefoxPortable.exe'), 'http://start.portableapps.com/', Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.ChangeMenuFontSize(intFontSize: integer);
// Change the font size of the menu components
begin
  sbtnApplication1.font.size:=intFontSize;
  sbtnApplication2.font.size:=intFontSize;
  sbtnApplication3.font.size:=intFontSize;
  sbtnApplication4.font.size:=intFontSize;
  sbtnApplication5.font.size:=intFontSize;
  sbtnApplication6.font.size:=intFontSize;
  sbtnApplication7.font.size:=intFontSize;
  sbtnApplication8.font.size:=intFontSize;
  sbtnApplication9.font.size:=intFontSize;
  sbtnApplication10.font.size:=intFontSize;
  sbtnApplication11.font.size:=intFontSize;
  sbtnApplication12.font.size:=intFontSize;
  sbtnApplication13.font.size:=intFontSize;
  sbtnApplication14.font.size:=intFontSize;
  sbtnApplication15.font.size:=intFontSize;
  sbtnApplication16.font.size:=intFontSize;
  sbtnApplication17.font.size:=intFontSize;
  sbtnApplication18.font.size:=intFontSize;
  sbtnDocuments.font.size:=intFontSize;
  sbtnMusic.font.size:=intFontSize;
  sbtnPictures.font.size:=intFontSize;
  sbtnVideo.font.size:=intFontSize;
  sbtnExplore.font.size:=intFontSize;
  sbtnBackup.font.size:=intFontSize;
  sbtnOptions.font.size:=intFontSize;
  sbtnHelp.font.size:=intFontSize;
  sbtnSearch.font.size:=intFontSize;
end;

// =====================================

procedure TfrmMenu.InitButtons(intListLength: Integer);
// Initialize the button array.
var
  intCounter: Integer;
begin
  // map our app buttons on the form to the array
  SetLength(arrAppButtons, 20);
  arrAppButtons[0]:=sbtnApplication1;
  arrAppButtons[1]:=sbtnApplication2;
  arrAppButtons[2]:=sbtnApplication3;
  arrAppButtons[3]:=sbtnApplication4;
  arrAppButtons[4]:=sbtnApplication5;
  arrAppButtons[5]:=sbtnApplication6;
  arrAppButtons[6]:=sbtnApplication7;
  arrAppButtons[7]:=sbtnApplication8;
  arrAppButtons[8]:=sbtnApplication9;
  arrAppButtons[9]:=sbtnApplication10;
  arrAppButtons[10]:=sbtnApplication11;
  arrAppButtons[11]:=sbtnApplication12;
  arrAppButtons[12]:=sbtnApplication13;
  arrAppButtons[13]:=sbtnApplication14;
  arrAppButtons[14]:=sbtnApplication15;
  arrAppButtons[15]:=sbtnApplication16;
  arrAppButtons[16]:=sbtnApplication17;
  arrAppButtons[17]:=sbtnApplication18;
  arrAppButtons[18]:=sbtnApplication19;
  arrAppButtons[19]:=sbtnApplication20;

  // Dynamically generate new buttons if needed
  if intListLength > 20 then
  begin
    // Increase the size of the array
    SetLength(arrAppButtons, intListLength);
    for intCounter := 20 to intListLength - 1 do
    begin
      // Create new button
      arrAppButtons[intCounter]:=TSpeedButton.Create(self);
      // Copy properties
      with arrAppButtons[intCounter] do
      begin
        // Initialize
        Parent := frmMenu;
        Name := 'dynsbtnApplication'+IntToStr(intCounter+1);
        Caption := arrAppButtons[intCounter].Name;

        // Copy Visual options
        Hint := arrAppButtons[0].Hint;
        ParentShowHint := arrAppButtons[0].ParentShowHint;
        ShowHint := arrAppButtons[0].ShowHint;
        Height := arrAppButtons[0].Height;
        Width := arrAppButtons[0].Width;
        Top := arrAppButtons[0].Top+22*intCounter;
        Left := arrAppButtons[0].Left;
        Glyph := arrAppButtons[0].Glyph;
        Font := arrAppButtons[0].Font;
        ParentFont := arrAppButtons[0].ParentFont;
        Margins := arrAppButtons[0].Margins;
        Margin := arrAppButtons[0].Margin;
        Flat := arrAppButtons[0].Flat;
        Transparent := arrAppButtons[0].Transparent;
        Visible := True;

        // Copy Events
        OnClick := arrAppButtons[0].OnClick;
        OnMouseUp := arrAppButtons[0].OnMouseUp;
      end;
    end;
    if not bolSeperateAppArrows then
      sbtnScrollDown.Top := arrAppButtons[intListLength-1].Top + 23;
  end;
end;

// =====================================

procedure TFrmMenu.SetupButtonsFromDB();
// Set up the icon list from a pre-built database
var
  intCounter: Integer;
  FileInfo: TSHFileInfo;
begin
  // Load the apps from the DB
  tstrlstApplications:=GetStoredSection('AppDB');

  // Set icon array to the same length as the app array
  SetLength(arrAppIcons,tstrlstApplications.Count);

  // Load the icons
  for intCounter:=0 to tstrlstApplications.Count - 1 do
  begin
    FillChar(FileInfo, SizeOf(FileInfo), #0);
    SHGetFileInfo(PChar(tstrlstApplications.ValueFromIndex[intCounter]),0, FileInfo, SizeOf(FileInfo), SHGFI_ICON or SHGFI_SMALLICON );
    arrAppIcons[intCounter]:= FileInfo.hIcon;
  end;

  bolFirstRefresh:=false;
end;

// =====================================

procedure TFrmMenu.SetupButtons();
// Search for the installed apps and index them in the list and button arrays
var
  strPortableAppsPath: String;
  tsrchDirectory: TSearchRec;
  tsrchSubDirectory: TSearchRec;
  strTempSubDir: String;
  strCurrentAppName: String;
  strCurrentAppPath: String;
  strCurrentAppVisible : String; //Could've been boolean with error check, but this is easier
  intCounter: integer;
  ptrFileInfo: pointer;
  lngFileInfoSize: Longint;
  dwdFileInfoLength: DWORD;
  ptrFileInfoLanguage : Pointer;
  ptrFileInfoData: Pointer;
  strFileInfoQuery: String;
  uintFileInfoDataLength: Uint;
  FileInfo: TSHFileInfo;
  iniPafData: TINIFile;
begin
  tstrlstApplications:= TStringList.Create; // setup the array for app names, paths
  tstrlstApplications.Sorted:= false;
  strPortableAppsPath:= ExtractFileDir(ExtractFileDir(ParamStr(0)))+'\';

  // process each directory 'next to' the PortableAppsMenu directory
  If FindFirst(strPortableAppsPath+'*',faAnyFile,tsrchDirectory)=0 Then
  begin
    Repeat
      If ((tsrchDirectory.Attr And faDirectory)<>0) Then
      begin
        strTempSubDir:=tsrchDirectory.FindData.cFileName;
        // Filter out the parent, current, PortableAppsMenu and PortableAppsBackup directories
        if (strTempSubDir <> '.') and (strTempSubDir <> '..') and (strTempSubDir <> 'PortableAppsMenu') and (strTempSubDir <> 'PortableAppsBackup') then
        begin
          // process each EXE in the current subdirectory
          If FindFirst(strPortableAppsPath+tsrchDirectory.FindData.cFileName+'\*.exe',faAnyFile,tsrchSubDirectory)=0 Then
          begin
            Repeat
              // Ensure it's not a directory with a .exe name
              If ((tsrchSubDirectory.Attr And faDirectory)=0) Then
              begin
                // Store our current EXE for use
                strCurrentAppPath:=strPortableAppsPath+tsrchDirectory.FindData.cFileName+'\'+tsrchSubDirectory.FindData.cFileName;
                strCurrentAppName:='';
                // Ensure that the current file has file info associated
                lngFileInfoSize:=GetFileVersionInfoSize(PChar(strCurrentAppPath), dwdFileInfoLength);
                if (lngFileInfoSize > 0) then
                begin
                  GetMem(ptrFileInfo, lngFileInfoSize);
                  try
                    // Check if the current app has a ProductName
                    if GetFileVersionInfo(PChar(strCurrentAppPath), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
                      begin
                        strFileInfoQuery:='ProductName';
                        if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
                          strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
                                  HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
                        if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
                          strCurrentAppName:=strPas(ptrFileInfoData);
                      end;
                  finally
                    FreeMem(ptrFileInfo, lngFileInfoSize);
                  end;
                  if strCurrentAppName='' then
                  begin
                    GetMem(ptrFileInfo, lngFileInfoSize);
                    try
                      // Check if the current app has a FileDescription
                      if GetFileVersionInfo(PChar(strCurrentAppPath), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
                        begin
                          strFileInfoQuery:='FileDescription';
                          if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
                            strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
                                    HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
                          if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
                            strCurrentAppName := strPas(ptrFileInfoData);
                        end;
                    finally
                      FreeMem(ptrFileInfo, lngFileInfoSize);
                    end;
                  end;
                end;
                strCurrentAppVisible:='true';
                // Look for a 'filename.pafdata' file, if found use it for the name
                if FileExists(LeftStr(strCurrentAppPath,length(strCurrentAppPath)-4) + '.pafdata') then
                  begin
                    iniPafData:=TINIFile.Create(LeftStr(strCurrentAppPath,length(strCurrentAppPath)-4) + '.pafdata');
                    strCurrentAppName:=iniPafData.ReadString('PAFDATA', 'Name', strCurrentAppName);
                    strCurrentAppVisible:=AnsiLowerCase(iniPafData.ReadString('PAFDATA', 'Visible', 'true'));
                    // If this is our initial refresh
                    if bolFirstRefresh then
                      // Run automatically if Autoexec is true
                      if AnsiLowerCase(iniPafData.ReadString('PAFDATA', 'Autoexec', 'false'))='true' then begin
                        bolVisible:=true;
                        ShellExecute(0,'open', PAnsiChar(strCurrentAppPath),Nil, Nil, SW_SHOW);
                        bolVisible:=false;
                      end;

                      // Delete pafdata if everything is at the default settings
                      if (FileExists(LeftStr(strCurrentAppPath,length(strCurrentAppPath)-4) + '.pafdata'))
                         and (FileGetAttr(LeftStr(strCurrentAppPath,length(strCurrentAppPath)-4) + '.pafdata') and faReadOnly = 0)
                         and (AnsiLowerCase(iniPafData.ReadString('PAFDATA', 'Autoexec', 'false'))='false')
                         and (ansiLowerCase(strCurrentAppVisible)='true')
                         and (iniPafData.ReadString('PAFDATA', 'Name', '')='') then
                         DeleteFile(LeftStr(strCurrentAppPath,length(strCurrentAppPath)-4) + '.pafdata');

                    iniPafData.Free;
                  end;
                // If still no App Name, use the filename without the .exe
                if strCurrentAppName='' then
                begin
                  strCurrentAppName:=tsrchSubDirectory.FindData.cFileName;
                  strCurrentAppName:=LeftStr(strCurrentAppName,length(strCurrentAppName)-4);
                end;
                //Check to make sure 'strCurrentAppVisible' is true or apps aren't being hidden
                if (strCurrentAppVisible<>'false') or (pmnuitmOptionsUnhideApps.Checked=True) then
                  // Ignore the OpenOffice.org Portable base launcher
                  // *TODO - This is a temporary hack until support for PAF's multi icon support is added
                  if strCurrentAppName<>'OpenOffice.org Portable' then
                    tstrlstApplications.Add(strCurrentAppName+'='+strCurrentAppPath);
              end;
            Until FindNext(tsrchSubDirectory)<>0;
          End;
        End;
      End;
    Until FindNext(tsrchDirectory)<>0;
  end;

  // Sort the applications into alphabetical order
  tstrlstApplications.Sort;

  // Set icon array to the same length as the app array
  SetLength(arrAppIcons,tstrlstApplications.Count);

  // Load the icons
  for intCounter:=0 to tstrlstApplications.Count - 1 do
  begin
    FillChar(FileInfo, SizeOf(FileInfo), #0);
    SHGetFileInfo(PChar(tstrlstApplications.ValueFromIndex[intCounter]),0, FileInfo, SizeOf(FileInfo), SHGFI_ICON or SHGFI_SMALLICON );
    arrAppIcons[intCounter]:= FileInfo.hIcon;
  end;

  bolFirstRefresh:=false;
end;

// =====================================

procedure TfrmMenu.DisplayButtons();
// Draw the icons onto the menu buttons
var
  intCurrentButton: integer;
  brshIcon: hBrush;
begin
  // If we have more applications that app icon positions, enable scrolling
  if tstrlstApplications.Count > High( arrAppButtons )+1 then
    sbtnScrollDown.Visible:=True;

  // Set customizable button captions
  sbtnDocuments.Caption:=GetStoredVariable('sbtnDocuments_NAME', sbtnDocuments.Caption);
  sbtnMusic.Caption:=GetStoredVariable('sbtnMusic_NAME', sbtnMusic.Caption);
  sbtnPictures.Caption:=GetStoredVariable('sbtnPictures_NAME', sbtnPictures.Caption);
  sbtnVideo.Caption:=GetStoredVariable('sbtnVideo_NAME', sbtnVideo.Caption);

  // Loop through the set of buttons
  for intCurrentButton := 0 to length(arrAppButtons)-1 do
  begin
    // If we have an app for this button...
    if intCurrentButton < tstrlstApplications.Count then
    begin
      // Set the offsets
      arrAppButtons[intCurrentButton].Left:=15+intAppOffsetX;
      arrAppButtons[intCurrentButton].Top:=82+(22*intCurrentButton)+intAppOffsetY;
      // Ensure the button is visible
      arrAppButtons[intCurrentButton].Visible:= True;

      // Set caption to the name and hint to the location
      arrAppButtons[intCurrentButton].Caption:=tstrlstApplications.Names[intCurrentButton+intFirstButton];
      arrAppButtons[intCurrentButton].Hint:='Location: ' + ExtractFileDir(tstrlstApplications.ValueFromIndex[intCurrentButton+intFirstButton]);
      //* TODO - Add the full name and version once PAF format support is complete
      // arrAppButtons[intCurrentButton].Hint:='Mozilla Firefox - Portable Edition 2.0'+#13#10+'Location: ' + ExtractFileDir(tstrlstApplications.ValueFromIndex[intCurrentButton+intFirstButton]);

      // Draw the icons into the button glyphs
      brshIcon:= CreateSolidBrush(clWhite);
      arrAppButtons[intCurrentButton].Glyph.Canvas.Rectangle(0,0,16,16);
      // Set transparent color & font (if set)
      if fntAppFont<>nil then
        arrAppButtons[intCurrentButton].Font:=fntAppFont;
      arrAppButtons[intCurrentButton].Glyph.TransparentColor:= colAppTransparentColor;
      DrawIconEx(arrAppButtons[intCurrentButton].Glyph.Canvas.Handle, 0, 0, arrAppIcons[intCurrentButton+intFirstButton], 16, 16, 0, brshIcon, DI_NORMAL);
      arrAppButtons[intCurrentButton].Glyph.Canvas.Refresh;
      DeleteObject(brshIcon);
      // Bring the button to the front of the Z-order, so custom images don't mess with it
      arrAppButtons[intCurrentButton].BringToFront;
    end else
      // hide the button if we have no app for it
      arrAppButtons[intCurrentButton].Visible:= False;
  end;

  // Brind the scroll buttons to the front of the Z-order
  sbtnScrollUp.BringToFront;
  sbtnScrollDown.BringToFront;

  // Set the X offsets for the scroll-up and scroll-down buttons
  if not BolSeperateAppArrows then
  begin
    sbtnScrollUp.Left := 15+intAppOffsetX;;
    sbtnScrollDown.Left := 15+intAppOffsetX;;
  end;
end;

// =====================================

procedure TfrmMenu.ClearButtons();
// Clear out our set of icons and release the associated memory
var
  intCounter: integer;
begin
  // Destroy each icon in the array
  for intCounter:=0 to tstrlstApplications.Count - 1 do
    DestroyIcon(arrAppIcons[intCounter]);

  // Clear out our app name/path array
  tstrlstApplications.free;

  // Reset Scroll Buttons
  sbtnScrollUp.Visible:=false;
  sbtnScrollDown.Visible:=false;
end;

// =====================================

procedure TfrmMenu.SetupMenus();
// Set up the Locale & Theme menus
// Acknowledgement: http://delphi.about.com/od/kbcurt/a/dynamicmenuitem.htm for the handy tutorial
var
  pmnuitmTemp: TMenuItemExtended;
  tsrchDirectory: TSearchRec;
begin
  // Clear the menus
  pmnuitmOptionsLocale.Clear;
  pmnuitmOptionsTheme.Clear;
  // Set up locale menu
  if FindFirst(ExtractFileDir(ParamStr(0)) + '\Data\Locale\*.locale',faAnyFile,tsrchDirectory)=0 then
  begin
    repeat
      pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLocale);
      pmnuitmTemp.Value:=ExtractFileDir(ParamStr(0)) + '\Data\Locale\' + tsrchDirectory.FindData.cFileName;
      pmnuitmTemp.Caption:=LeftStr(ExtractFileName(pmnuitmTemp.Value), Length(ExtractFileName(pmnuitmTemp.Value))-7);
      pmnuitmTemp.OnClick:=pmnuitmLocaleClick;
      pmnuitmTemp.RadioItem:=True;
      // If it's the currently enabled locale, enable it's menu option
      if AnsiLowerCase(tsrchDirectory.FindData.cFileName)=AnsiLowerCase(strLocale) then
        pmnuitmTemp.Checked:=true;
      pmnuitmOptionsLocale.Add(pmnuitmTemp);
    Until FindNext(tsrchDirectory)<>0;
  end
  else
  begin
    // Insert dummy item to make it look like a submenu
    pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLocale);
    pmnuitmOptionsLocale.Add(pmnuitmTemp);
    pmnuitmOptionsLocale.Enabled:=False;
  end;
  // Set up theme menu
  if FindFirst(ExtractFileDir(ParamStr(0)) + '\Data\Theme\*',faDirectory,tsrchDirectory)=0 then
  begin
    repeat
      // Make sure it's a directory and filter out the '.' and '..' directories
      If ((tsrchDirectory.Attr And faDirectory)<>0) And (tsrchDirectory.Name<>'.') And (tsrchDirectory.Name<>'..') Then
      begin
        pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsTheme);
        pmnuitmTemp.Value:=tsrchDirectory.FindData.cFileName;
        pmnuitmTemp.Caption:=ExtractFileName(pmnuitmTemp.Value);
        pmnuitmTemp.OnClick:=pmnuitmThemeClick;
        pmnuitmTemp.RadioItem:=True;
        // If it's the currently enabled theme, enable it's menu option
        if AnsiLowerCase(tsrchDirectory.FindData.cFileName)=AnsiLowerCase(strTheme) then
          pmnuitmTemp.Checked:=true;
        pmnuitmOptionsTheme.Add(pmnuitmTemp);
      end;
    Until FindNext(tsrchDirectory)<>0;
  end
  else
  begin
    // Insert dummy item to make it look like a submenu
    pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsTheme);
    pmnuitmOptionsTheme.Add(pmnuitmTemp);
    pmnuitmOptionsTheme.Enabled:=False;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmLocaleClick(Sender : TObject);
// Click handler for the locale menu
begin
  //Get the locale name from the menu caption
  strLocale:=RightStr(TMenuItemExtended(Sender).Caption+'.locale', Length(TMenuItemExtended(Sender).Caption+'.locale')-1);
  LoadLocale();
  // Redisplay any custom buttons
  DisplayButtons;
  lblDriveSpace.Caption:= strDriveFree + ' ' + strFreeOf + ' ' + strDriveSize;
end;

// =====================================

procedure TfrmMenu.pmnuitmThemeClick(Sender : TObject);
// Theme menu click handler
begin
  // Set strTheme from the Value option
  strTheme:=TMenuItemExtended(Sender).Value;
  LoadTheme();
end;

// =====================================

procedure TfrmMenu.pmnuOptionsPopup(Sender: TObject);
// Unhide the TrayIcon-exclusive buttons if tag is not equal to 1
begin
  if TPopupMenu(Sender).Tag = 1 then
  begin
    pmnuitmOptionsDivider4.Visible :=( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsRestorePosition.Visible := ( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsShowHideMenu.Visible:=False;
    pmnuitmOptionsExit.Visible:=False;
  end
  else
  begin
    pmnuitmOptionsDivider4.Visible:=True;
    pmnuitmOptionsRestorePosition.Visible := ( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsShowHideMenu.Visible:=True;
    pmnuitmOptionsExit.Visible:=True;
  end;
end;

// =====================================

function TfrmMenu.GetStoredVariable(strVariable: String; strDefault: String) : String;
// Get a variable stored in the configuration ini
var
  iniSettings: TINIFile;
  strIniLocation : String;
begin
  strIniLocation:=LeftStr(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)),length(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)))-4) + '.ini';
  if FileExists(strIniLocation) then begin
    iniSettings:=TINIFile.Create(strIniLocation);
    result:=iniSettings.ReadString('SETTINGS', strVariable, strDefault);
    iniSettings.Free;
  end
  else
    result:=strDefault;
end;

// =====================================

procedure TfrmMenu.SetStoredVariable(strVariable: String; strSetting: String);
// Insert a variable into the configuration ini
var
  iniSettings: TINIFile;
  strIniLocation : String;
begin
  strIniLocation:=LeftStr(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)),length(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)))-4) + '.ini';
  iniSettings:=TINIFile.Create(strIniLocation);
  iniSettings.WriteString('SETTINGS', strVariable, strSetting);
  iniSettings.UpdateFile();
  iniSettings.Free();
end;

// =====================================

function TfrmMenu.GetStoredSection(strSection: String) : TStringList;
// Get an enire section of settings
var
  iniSettings: TINIFile;
  strIniLocation : String;
  lstResult: TStringList;
begin
  strIniLocation:=ChangeFileExt(ParamStr(0), '.ini');
  iniSettings:=TINIFile.Create(strIniLocation);
  lstResult:=TStringList.Create;
  inisettings.ReadSectionValues(strSection, lstResult);
  result:=lstResult;
  iniSettings.Free;
end;

// =====================================

procedure TfrmMenu.SetStoredSection(strSection: String; tstrlstContents: TStringList);
// Insert a TStringList into the config file
var
  iniSettings: TINIFile;
  intCounter: Integer;
  strIniLocation : String;
begin
  strIniLocation:=ChangeFileExt(ParamStr(0), '.ini');
  iniSettings:=TINIFile.Create(strIniLocation);
  iniSettings.EraseSection(strSection);
  for intCounter := 0 to tstrlstContents.Count - 1 do
  begin
    iniSettings.WriteString(strSection,
      tstrlstContents.Names[intCounter],
      tstrlstContents.ValueFromIndex[intCounter]
    );
  end;
  iniSettings.Free;
end;

// =====================================

function TfrmMenu.GetWallpaper() : String;
// Get the path to the current wallpaper
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('Wallpaper');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

function TfrmMenu.GetWallpaperStyle() : String;
// Get the Wallpaper Style (EG tiled, stretched, etc)
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('WallpaperStyle');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

function TfrmMenu.GetTileWallpaper() : String;
// Get the Tile Wallpaper setting
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('TileWallpaper');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

procedure TfrmMenu.SetWallpaper(strFilename, strWallpaperStyle, strTileWallpaper: String);
// Set a new wallpaper
var
  regWallpaper: TRegistry;
begin
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
    regWallpaper.WriteString('Wallpaper', strFilename);
    regWallpaper.WriteString('WallpaperStyle', strWallpaperStyle);
    regWallpaper.WriteString('TileWallpaper', strTileWallpaper);
    SystemParametersInfo (SPI_SETDESKWALLPAPER,0, nil,SPIF_SENDWININICHANGE) ;
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

procedure TfrmMenu.LoadLocale();
// Load locale file
var
  iniLocale: TINIFile;
begin
  iniLocale:=TINIFile.Create(ExtractFileDir(ParamStr(0))+'\Data\Locale\'+strLocale);
  strLocaleVersion:=iniLocale.ReadString('LOCALE', 'VERSION', ' out of date or unavaliable');
  sbtnDocuments.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_DOCUMENTS', 'Documents');
  sbtnMusic.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_MUSIC', 'Music');
  sbtnPictures.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_PICTURES', 'Pictures');
  sbtnVideo.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_VIDEO', 'Video');
  sbtnExplore.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_EXPLORE', 'Explore');
  sbtnBackup.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_BACKUP', 'Backup');
  sbtnOptions.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_OPTIONS', 'Options');
  sbtnHelp.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_HELP', 'Help');
  sbtnSearch.Caption:=iniLocale.ReadString('FORM_MAIN', 'ICON_SEARCH', 'Search');
  pmnuitmOptionsSmallFonts.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_SMALL_FONTS', 'Small Fonts');
  pmnuitmOptionsLargeFonts.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_LARGE_FONTS', 'Large Fonts');
  pmnuitmOptionsLocale.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_LOCALE', 'Language');
  pmnuitmOptionsTheme.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_THEME', 'Theme');
  pmnuitmOptionsUnhideApps.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_UNHIDE_APPS', 'Unhide Apps');
  pmnuitmOptionsAddApp.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_ADD_APP', 'Install a New App');
  pmnuitmOptionsRemoveApp.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_REMOVE_APP', 'Remove an App');
  pmnuitmOptionsRefreshApps.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_REFRESH_ICONS', 'Refresh App Icons');
  pmnuitmOptionsGetMore.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_GET_APPS', 'Get More Apps...');
  pmnuitmOptionsStayVisible.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_STAY_VISIBLE', 'Stay Visible');
  pmnuitmOptionsSnapToScreen.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_SNAP_TO_SCREEN', 'Snap to Screen');
  pmnuitmOptionsDisableFade.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_DISABLE_FADE', 'Disable Fade Effect');
  pmnuitmOptionsLoadFromDB.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_LOAD_APPS_FROM_DB', 'Load Apps from DB');
  pmnuitmOptionsLoadWallpaper.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_ENABLE_WALLPAPER_SWAP', 'Enable Wallpaper Swap');
  pmnuitmOptionsRestorePosition.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_RESTORE_POSITION', 'Restore Position');
  pmnuitmOptionsShowHideMenu.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_SHOW_HIDE_MENU', 'Show/Hide Menu');
  pmnuitmOptionsExit.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_EXIT', 'Exit');
  pmnuitmPafDataHideApp.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_PAFDATA_HIDE_APP', 'Hide App');
  pmnuitmPafDataRenameApp.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_PAFDATA_RENAME_APP', 'Rename App');
  pmnuitmPafDataExecOnClose.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_PAFDATA_EXEC_ON_CLOSE', 'Exec on Close');
  strAppRenameMessage:=iniLocale.ReadString('FORM_MAIN', 'MENU_PAFDATA_RENAME_MESSAGE', 'Enter the application''s new name');
  pmnuitmPafDataAutoRunApp.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_PAFDATA_AUTOEXEC_APP', 'Autorun App');
  pmnuitmBackup.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_BACKUP', 'Backup Files');
  pmnuitmRestore.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_RESTORE', 'Restore From Backup');
  pmnuitmSearchDrive.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_SEARCH_DRIVE', 'Search This Drive');
  pmnuitmSearchComputer.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_SEARCH_COMPUTER', 'Search This Computer');
  pmnuitmSearchWeb.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_SEARCH_WEB', 'Search The Web');
  pmnuitmCustButtonsRename.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME', 'Rename Button');
  strRenameButtonCaption:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME_CAPTION', 'Rename Button');
  strRenameButtonPrompt:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME_PROMPT', 'Please enter the new name for this customizable button');
  pmnuitmCustButtonsChange.Caption:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE', 'Change Button Path');
  strChangeButtonCaption:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE_CAPTION', 'Change Button Path');
  strChangeButtonPrompt:=iniLocale.ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE_PROMPT', 'Please enter the path to the directory you wish to assign to this button (excluding the drive letter)');
  strAppRemoveMessage:=iniLocale.ReadString('FORM_MAIN', 'MENU_OPTIONS_REMOVE_APP_MESSAGE', 'To remove an application, delete it''s directory in the PortableApps folder and restart the Portable Apps Menu. When you press OK, the PortableApps folder will be loaded.');
  strDefaultThemeCorrupted:=iniLocale.ReadString('ERRORS', 'DEFAULT_THEME_CORRUPTED', 'The default theme is either corrupted or not installed correctly and the program cannot continue. Please reinstall the application to correct this problem.');
  strSelectedThemeCorrupted:=iniLocale.ReadString('ERRORS', 'SELECTED_THEME_CORRUPTED', 'The theme you last selected, ''%s'', is not installed correctly, has been deleted or is corrupted. You are now being automatically reverted to the default theme.');
  strHelpDialog:=iniLocale.ReadString('ERRORS', 'HELP_UNSUPPORTED', 'PortableApps Menu MOD (version %s, locale %s) is a modification of the PortableApps Menu and is not supported by PortableApps.com. For more information, visit the PortableApps.com forum and search for PortableAppsMenu MOD.');
  strRegisterHotkeyError:=iniLocale.ReadString('ERRORS', 'REGISTER_HOTKEY_ERROR', 'Global Hotkey could not be registered. This is likely because another program is using the Shift-Win or Shift-F11 hotkey.');
  strInstallMessage:=iniLocale.ReadString('FORM_INSTALL', 'INSTALL_MESSAGE', 'Applications in PortableApps Format can be installed automatically by the PortableApps Menu.'+' After you''ve downloaded the app you''d like to install -- the files end in .paf.exe -- just click the install button below and select the file.  PortableApps Menu will take care of the rest.');
  strAppInstallFailed:=iniLocale.ReadString('FORM_INSTALL', 'INSTALL_FAILED', 'Could not execute %s');
  strAppInstallButtonOK:=iniLocale.ReadString('FORM_INSTALL', 'INSTALL_BUTTON_INSTALL', 'Install');
  strAppInstallButtonCancel:=iniLocale.ReadString('FORM_INSTALL', 'INSTALL_BUTTON_CANCEL', 'Cancel');
  strFreeOf:=iniLocale.ReadString('FORM_MAIN', 'DRIVE_SPACE_FREE', 'free of');
  iniLocale.Free;

  // Reload our menus
  SetupMenus;
end;

// =====================================

procedure TfrmMenu.LoadTheme();
// Load theme data
var
  jpgTempImage: TJPEGImage;
  bmpTempImage: TBitmap;
  iniTheme: TINIFile;
  strSection: String;
  strBorderType: String;
  strlstCustomImages: TStringList;
  intCounter: Integer;
  mtdOnClickMethod: TMethod;

begin
  // Refresh the menus
  SetupMenus;

  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg')<>True then
  begin
    if (AnsiLowerCase(strTheme)='default') then
      begin
        ShowMessage(strDefaultThemeCorrupted);
        bolIsLive:=True; // Make sure we don't edit the ini file by mistake
        Application.Terminate;
        exit;
      end
      else
      begin
        ShowMessageFmt(strSelectedThemeCorrupted, [strTheme]);
        strTheme:='default';
        // Check that the default theme exists
        if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg')<>True then
        begin
          ShowMessage(strDefaultThemeCorrupted);
          bolIsLive:=True; // Make sure we don't edit the ini file by mistake
          Application.Terminate;
          exit;
        end;
      end;
  end;

  // Check that the icontheme exists
  strIconTheme:=strTheme;
  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico')<>True then
  begin
    //If it doesn't, load the default icontheme
    strIconTheme:='default';
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico')<>True then
    begin
      ShowMessage(strDefaultThemeCorrupted);
      bolIsLive:=True; // Make sure we don't edit the ini file by mistake
      Application.Terminate;
      exit;
    end;
  end;

  // Load Theme
  jpgTempImage := TJPEGImage.Create;
  jpgTempImage.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg');
  imgBackground.Canvas.Draw(0,0,jpgTempImage);
  jpgTempImage.Free;
  bmpTempImage := TBitmap.Create;
  bmpTempImage.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background_top.bmp');
  imgBackground.Canvas.Draw(0,0,bmpTempImage);
  bmpTempImage.Free;
  imgDriveSpace.Picture.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/drive_space_slider.bmp');

  // Load Icons
  imgBackup.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico');
  imgDocuments.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/documents.ico');
  imgExplore.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/explore.ico');
  imgHelp.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/help.ico');
  imgMusic.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/music.ico');
  imgOptions.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/options.ico');
  imgPictures.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/pictures.ico');
  imgSearch.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/search.ico');
  imgVideo.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/video.ico');

  // If a Theme.INI file exists, use it to recolor the text/reposition the buttons
  // Otherwise, use the default theme's theme.ini
  // WARNING: Massive block of code ahead
  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini') then
  begin
    {$ifdef RedirectThemeINI}
    iniTheme:=TINIRedirect.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini');
    {$else}
    iniTheme:=TINIFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini');
    {$endif}
  end
  else
  begin
    // Check for default theme
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/IconTheme/backup.ico')<>True then
    begin
      ShowMessage(strDefaultThemeCorrupted);
      bolIsLive:=True; // Make sure we don't edit the ini file by mistake
      Application.Terminate;
      exit;
    end;

    {$ifdef RedirectThemeINI}
    iniTheme:=TINIRedirect.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$else}
    iniTheme:=TINIFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$endif}
  end;
    // Main Form
    begin
      frmMenu.Height:=iniTheme.ReadInteger('frmMenu', 'Height', frmMenu.Height);
      frmMenu.Width:=iniTheme.ReadInteger('frmMenu', 'Width', frmMenu.Width);
      // Set border type
      strBorderType:=ansiLowerCase(iniTheme.ReadString('frmMenu', 'BorderStyle', 'bsnone'));
      if strBorderType = 'bsnone' then
        frmMenu.BorderStyle:=bsNone
      else if strBorderType = 'bsdialog' then
       frmMenu.BorderStyle:=bsDialog
      else if strBorderType = 'bssingle' then
       frmMenu.BorderStyle:=bsSingle
      else if strBorderType = 'bssizeable' then
       frmMenu.BorderStyle:=bsSizeable
      else if strBorderType = 'bssizeoolwin' then
       frmMenu.BorderStyle:=bsSizeToolWin
      else if strBorderType = 'bstoolwindow' then
       frmMenu.BorderStyle:=bsToolWindow;

      // Set form color
      frmMenu.Color:=RGB(
        iniTheme.ReadInteger('frmMenu', 'ColorR', GetRValue(frmMenu.Color)),
        iniTheme.ReadInteger('frmMenu', 'ColorG', GetGValue(frmMenu.Color)),
        iniTheme.ReadInteger('frmMenu', 'ColorB', GetBValue(frmMenu.Color))
        );
      // Side/offset settings
      bolSwitchSide:=iniTheme.ReadBool('frmMenu', 'SwitchSides', False);
      intDefaultOffsetX:=OffsetToInt(iniTheme.ReadString('frmMenu', 'OffsetX', '-4'), Screen.WorkAreaRect.Right);
      intDefaultOffsetY:=OffsetToInt(iniTheme.ReadString('frmMenu', 'OffsetY', '-4'), Screen.WorkAreaRect.Bottom);
      ApplyThemeOffsets; // Thought I'd need it in more places, (XrXca)
    end;

    // imgBackground
    strSection:='imgBackground';
    begin
      imgBackground.Height:=iniTheme.ReadInteger(strSection, 'Height', imgBackground.Height);
      imgBackground.Width:=iniTheme.ReadInteger(strSection, 'Width', imgBackground.Width);
      imgBackground.Left:=iniTheme.ReadInteger(strSection, 'Left', imgBackground.Left);
      imgBackground.Top:=iniTheme.ReadInteger(strSection, 'Top', imgBackground.Top);
      imgBackground.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgBackground.Visible);
    end;

    // imgBackup
    strSection:='imgBackup';
    begin
      imgBackup.Height:=iniTheme.ReadInteger(strSection, 'Height', imgBackup.Height);
      imgBackup.Width:=iniTheme.ReadInteger(strSection, 'Width', imgBackup.Width);
      imgBackup.Left:=iniTheme.ReadInteger(strSection, 'Left', imgBackup.Left);
      imgBackup.Top:=iniTheme.ReadInteger(strSection, 'Top', imgBackup.Top);
      imgBackup.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgBackup.Visible);
    end;

    // imgClose
    strSection:='imgClose';
    begin
      imgClose.Height:=iniTheme.ReadInteger(strSection, 'Height', imgClose.Height);
      imgClose.Width:=iniTheme.ReadInteger(strSection, 'Width', imgClose.Width);
      imgClose.Left:=iniTheme.ReadInteger(strSection, 'Left', imgClose.Left);
      imgClose.Top:=iniTheme.ReadInteger(strSection, 'Top', imgClose.Top);
      imgClose.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgClose.Visible);
    end;

    // imgDivider1
    strSection:='imgDivider1';
    begin
      imgDivider1.Height:=iniTheme.ReadInteger(strSection, 'Height', imgDivider1.Height);
      imgDivider1.Width:=iniTheme.ReadInteger(strSection, 'Width', imgDivider1.Width);
      imgDivider1.Left:=iniTheme.ReadInteger(strSection, 'Left', imgDivider1.Left);
      imgDivider1.Top:=iniTheme.ReadInteger(strSection, 'Top', imgDivider1.Top);
      imgDivider1.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgDivider1.Visible);
    end;

    // imgDivider2
    strSection:='imgDivider2';
    begin
      imgDivider2.Height:=iniTheme.ReadInteger(strSection, 'Height', imgDivider2.Height);
      imgDivider2.Width:=iniTheme.ReadInteger(strSection, 'Width', imgDivider2.Width);
      imgDivider2.Left:=iniTheme.ReadInteger(strSection, 'Left', imgDivider2.Left);
      imgDivider2.Top:=iniTheme.ReadInteger(strSection, 'Top', imgDivider2.Top);
      imgDivider2.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgDivider2.Visible);
    end;

    // imgDocuments
    strSection:='imgDocuments';
    begin
      imgDocuments.Height:=iniTheme.ReadInteger(strSection, 'Height', imgDocuments.Height);
      imgDocuments.Width:=iniTheme.ReadInteger(strSection, 'Width', imgDocuments.Width);
      imgDocuments.Left:=iniTheme.ReadInteger(strSection, 'Left', imgDocuments.Left);
      imgDocuments.Top:=iniTheme.ReadInteger(strSection, 'Top', imgDocuments.Top);
      imgDocuments.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgDocuments.Visible);
    end;

    // imgDriveSpace
    strSection:='imgDriveSpace';
    begin
      imgDriveSpace.Height:=iniTheme.ReadInteger(strSection, 'Height', imgDriveSpace.Height);
      imgDriveSpace.Left:=iniTheme.ReadInteger(strSection, 'Left', imgDriveSpace.Left);
      imgDriveSpace.Top:=iniTheme.ReadInteger(strSection, 'Top', imgDriveSpace.Top);
      imgDriveSpace.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgDriveSpace.Visible);
      imgDriveSpace.Stretch:=iniTheme.ReadBool(strSection, 'Stretch', imgDriveSpace.Stretch);
    end;

    // imgExplore
    strSection:='imgExplore';
    begin
      imgExplore.Height:=iniTheme.ReadInteger(strSection, 'Height', imgExplore.Height);
      imgExplore.Width:=iniTheme.ReadInteger(strSection, 'Width', imgExplore.Width);
      imgExplore.Left:=iniTheme.ReadInteger(strSection, 'Left', imgExplore.Left);
      imgExplore.Top:=iniTheme.ReadInteger(strSection, 'Top', imgExplore.Top);
      imgExplore.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgExplore.Visible);
    end;

    // imgHelp
    strSection:='imgHelp';
    begin
      imgHelp.Height:=iniTheme.ReadInteger(strSection, 'Height', imgHelp.Height);
      imgHelp.Width:=iniTheme.ReadInteger(strSection, 'Width', imgHelp.Width);
      imgHelp.Left:=iniTheme.ReadInteger(strSection, 'Left', imgHelp.Left);
      imgHelp.Top:=iniTheme.ReadInteger(strSection, 'Top', imgHelp.Top);
      imgHelp.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgHelp.Visible);
    end;

    // imgMusic
    strSection:='imgMusic';
    begin
      imgMusic.Height:=iniTheme.ReadInteger(strSection, 'Height', imgMusic.Height);
      imgMusic.Width:=iniTheme.ReadInteger(strSection, 'Width', imgMusic.Width);
      imgMusic.Left:=iniTheme.ReadInteger(strSection, 'Left', imgMusic.Left);
      imgMusic.Top:=iniTheme.ReadInteger(strSection, 'Top', imgMusic.Top);
      imgMusic.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgMusic.Visible);
    end;

    // imgOptions
    strSection:='imgOptions';
    begin
      imgOptions.Height:=iniTheme.ReadInteger(strSection, 'Height', imgOptions.Height);
      imgOptions.Width:=iniTheme.ReadInteger(strSection, 'Width', imgOptions.Width);
      imgOptions.Left:=iniTheme.ReadInteger(strSection, 'Left', imgOptions.Left);
      imgOptions.Top:=iniTheme.ReadInteger(strSection, 'Top', imgOptions.Top);
      imgOptions.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgOptions.Visible);
    end;

    // imgPictures
    strSection:='imgPictures';
    begin
      imgPictures.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPictures.Height);
      imgPictures.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPictures.Width);
      imgPictures.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPictures.Left);
      imgPictures.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPictures.Top);
      imgPictures.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgPictures.Visible);
    end;

    // imgPortableAppsLogo1
    strSection:='imgPortableAppsLogo1';
    begin
      imgPortableAppsLogo1.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo1.Height);
      imgPortableAppsLogo1.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo1.Width);
      imgPortableAppsLogo1.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo1.Left);
      imgPortableAppsLogo1.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo1.Top);
    end;

    // imgPortableAppsLogo2
    strSection:='imgPortableAppsLogo2';
    begin
      imgPortableAppsLogo2.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo2.Height);
      imgPortableAppsLogo2.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo2.Width);
      imgPortableAppsLogo2.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo2.Left);
      imgPortableAppsLogo2.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo2.Top);
    end;

    // imgPortableAppsLogo3
    strSection:='imgPortableAppsLogo3';
    begin
      imgPortableAppsLogo3.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo3.Height);
      imgPortableAppsLogo3.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo3.Width);
      imgPortableAppsLogo3.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo3.Left);
      imgPortableAppsLogo3.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo3.Top);
    end;

    // imgPortableAppsLogo4
    strSection:='imgPortableAppsLogo4';
    begin
      imgPortableAppsLogo4.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo4.Height);
      imgPortableAppsLogo4.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo4.Width);
      imgPortableAppsLogo4.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo4.Left);
      imgPortableAppsLogo4.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo4.Top);
    end;

    // imgPortableAppsLogo5
    strSection:='imgPortableAppsLogo5';
    begin
      imgPortableAppsLogo5.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo5.Height);
      imgPortableAppsLogo5.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo5.Width);
      imgPortableAppsLogo5.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo5.Left);
      imgPortableAppsLogo5.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo5.Top);
    end;

    // imgPortableAppsLogo6
    strSection:='imgPortableAppsLogo6';
    begin
      imgPortableAppsLogo6.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogo6.Height);
      imgPortableAppsLogo6.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogo6.Width);
      imgPortableAppsLogo6.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogo6.Left);
      imgPortableAppsLogo6.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogo6.Top);
    end;

    // imgPortableAppsLogoPixel
    strSection:='imgPortableAppsLogoPixel';
    begin
      imgPortableAppsLogoPixel.Height:=iniTheme.ReadInteger(strSection, 'Height', imgPortableAppsLogoPixel.Height);
      imgPortableAppsLogoPixel.Width:=iniTheme.ReadInteger(strSection, 'Width', imgPortableAppsLogoPixel.Width);
      imgPortableAppsLogoPixel.Left:=iniTheme.ReadInteger(strSection, 'Left', imgPortableAppsLogoPixel.Left);
      imgPortableAppsLogoPixel.Top:=iniTheme.ReadInteger(strSection, 'Top', imgPortableAppsLogoPixel.Top);
    end;

    // imgSearch
    strSection:='imgSearch';
    begin
      imgSearch.Height:=iniTheme.ReadInteger(strSection, 'Height', imgSearch.Height);
      imgSearch.Width:=iniTheme.ReadInteger(strSection, 'Width', imgSearch.Width);
      imgSearch.Left:=iniTheme.ReadInteger(strSection, 'Left', imgSearch.Left);
      imgSearch.Top:=iniTheme.ReadInteger(strSection, 'Top', imgSearch.Top);
      imgSearch.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgSearch.Visible);
    end;

    // imgVideo
    strSection:='imgVideo';
    begin
      imgVideo.Height:=iniTheme.ReadInteger(strSection, 'Height', imgVideo.Height);
      imgVideo.Width:=iniTheme.ReadInteger(strSection, 'Width', imgVideo.Width);
      imgVideo.Left:=iniTheme.ReadInteger(strSection, 'Left', imgVideo.Left);
      imgVideo.Top:=iniTheme.ReadInteger(strSection, 'Top', imgVideo.Top);
      imgVideo.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgVideo.Visible);
    end;

    // imgVideo
    strSection:='imgVideo';
    begin
      imgVideo.Height:=iniTheme.ReadInteger(strSection, 'Height', imgVideo.Height);
      imgVideo.Width:=iniTheme.ReadInteger(strSection, 'Width', imgVideo.Width);
      imgVideo.Left:=iniTheme.ReadInteger(strSection, 'Left', imgVideo.Left);
      imgVideo.Top:=iniTheme.ReadInteger(strSection, 'Top', imgVideo.Top);
      imgVideo.Visible:=iniTheme.ReadBool(strSection, 'Visible', imgVideo.Visible);
    end;

    // lblDriveName
    strSection:='lblDriveName';
    begin
      lblDriveName.Height:=iniTheme.ReadInteger(strSection, 'Height', lblDriveName.Height);
      lblDriveName.Width:=iniTheme.ReadInteger(strSection, 'Width', lblDriveName.Width);
      lblDriveName.Left:=iniTheme.ReadInteger(strSection, 'Left', lblDriveName.Left);
      lblDriveName.Top:=iniTheme.ReadInteger(strSection, 'Top', lblDriveName.Top);
      lblDriveName.Visible:=iniTheme.ReadBool(strSection, 'Visible', lblDriveName.Visible);
      lblDriveName.Font.Name:=iniTheme.ReadString(strSection, 'Font', lblDriveName.Font.Name);
      lblDriveName.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(lblDriveName.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(lblDriveName.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(lblDriveName.Font.Color))
      );

      lblDriveName.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', False) then
        lblDriveName.Font.Style:=lblDriveName.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        lblDriveName.Font.Style:=lblDriveName.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        lblDriveName.Font.Style:=lblDriveName.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        lblDriveName.Font.Style:=lblDriveName.Font.Style + [fsStrikeOut];
    end;

    // lblDriveSpace
    strSection:='lblDriveSpace';
    begin
      lblDriveSpace.Height:=iniTheme.ReadInteger(strSection, 'Height', lblDriveSpace.Height);
      lblDriveSpace.Width:=iniTheme.ReadInteger(strSection, 'Width', lblDriveSpace.Width);
      lblDriveSpace.Left:=iniTheme.ReadInteger(strSection, 'Left', lblDriveSpace.Left);
      lblDriveSpace.Top:=iniTheme.ReadInteger(strSection, 'Top', lblDriveSpace.Top);
      lblDriveSpace.Visible:=iniTheme.ReadBool(strSection, 'Visible', lblDriveSpace.Visible);
      lblDriveSpace.Font.Name:=iniTheme.ReadString(strSection, 'Font', lblDriveSpace.Font.Name);
      lblDriveSpace.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(lblDriveSpace.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(lblDriveSpace.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(lblDriveSpace.Font.Color))
      );

      lblDriveSpace.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', False) then
        lblDriveSpace.Font.Style:=lblDriveSpace.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        lblDriveSpace.Font.Style:=lblDriveSpace.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        lblDriveSpace.Font.Style:=lblDriveSpace.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        lblDriveSpace.Font.Style:=lblDriveSpace.Font.Style + [fsStrikeOut];
    end;

    // AppButtons
    strSection:='AppButtons';
    begin
      colAppTransparentColor:=RGB(
        iniTheme.ReadInteger(strSection, 'TransparentColorR', GetRValue(sbtnApplication1.Glyph.TransparentColor)),
        iniTheme.ReadInteger(strSection, 'TransparentColorG', GetGValue(sbtnApplication1.Glyph.TransparentColor)),
        iniTheme.ReadInteger(strSection, 'TransparentColorB', GetBValue(sbtnApplication1.Glyph.TransparentColor))
      );

      fntAppFont:=TFont.Create();
      // Set everything in the font to the current settings
      fntAppFont:=sbtnApplication1.Font;
      // Load our new settings
      fntAppFont.Name:=iniTheme.ReadString(strSection, 'FontName', sbtnApplication1.Font.Name);
      fntAppFont.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'FontColorR', GetRValue(sbtnApplication1.Font.Color)),
        iniTheme.ReadInteger(strSection, 'FontColorG', GetGValue(sbtnApplication1.Font.Color)),
        iniTheme.ReadInteger(strSection, 'FontColorB', GetBValue(sbtnApplication1.Font.Color))
      );

      fntAppFont.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        fntAppFont.Style:=fntAppFont.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        fntAppFont.Style:=fntAppFont.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        fntAppFont.Style:=fntAppFont.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        fntAppFont.Style:=fntAppFont.Style + [fsStrikeOut];

      intAppOffsetX:=iniTheme.ReadInteger(strSection, 'OffsetX', 0);
      intAppOffsetY:=iniTheme.ReadInteger(strSection, 'OffsetY', 0);
      InitButtons(iniTheme.ReadInteger(strSection, 'ListSize', 20));
      // Set the seperate app arrows preference, if true use their individual offset/size controls
      bolSeperateAppArrows:=iniTheme.ReadBool(strSection, 'SeperateAppArrows', False)
    end;

    strSection:='sbtnScrollUp';
    begin
      sbtnScrollUp.Height:=iniTheme.ReadInteger(strSection, 'Height', 10);
      sbtnScrollUp.Width:=iniTheme.ReadInteger(strSection, 'Width', 240);
      sbtnScrollUp.Left:=iniTheme.ReadInteger(strSection, 'Left', 15);
      sbtnScrollUp.Top:=iniTheme.ReadInteger(strSection, 'Top', 70);
    end;

    strSection:='sbtnScrollDown';
    begin
      sbtnScrollDown.Height:=iniTheme.ReadInteger(strSection, 'Height', 10);
      sbtnScrollDown.Width:=iniTheme.ReadInteger(strSection, 'Width', 240);
      sbtnScrollDown.Left:=iniTheme.ReadInteger(strSection, 'Left', 15);
      sbtnScrollDown.Top:=iniTheme.ReadInteger(strSection, 'Top', 523);
    end;

    // sbtnBackup
    strSection:='sbtnBackup';
    begin
      sbtnBackup.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnBackup.Height);
      sbtnBackup.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnBackup.Width);
      sbtnBackup.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnBackup.Left);
      sbtnBackup.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnBackup.Top);
      sbtnBackup.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnBackup.Visible);
      sbtnBackup.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnBackup.Font.Name);
      sbtnBackup.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnBackup.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnBackup.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnBackup.Font.Color))
      );

      sbtnBackup.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnBackup.Font.Style:=sbtnBackup.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnBackup.Font.Style:=sbtnBackup.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnBackup.Font.Style:=sbtnBackup.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnBackup.Font.Style:=sbtnBackup.Font.Style + [fsStrikeOut];
    end;

    // sbtnDocuments
    strSection:='sbtnDocuments';
    begin
      sbtnDocuments.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnDocuments.Height);
      sbtnDocuments.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnDocuments.Width);
      sbtnDocuments.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnDocuments.Left);
      sbtnDocuments.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnDocuments.Top);
      sbtnDocuments.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnDocuments.Visible);
      sbtnDocuments.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnDocuments.Font.Name);
      sbtnDocuments.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnDocuments.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnDocuments.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnDocuments.Font.Color))
      );

      sbtnDocuments.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnDocuments.Font.Style:=sbtnDocuments.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnDocuments.Font.Style:=sbtnDocuments.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnDocuments.Font.Style:=sbtnDocuments.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnDocuments.Font.Style:=sbtnDocuments.Font.Style + [fsStrikeOut];
    end;

    // sbtnExplore
    strSection:='sbtnExplore';
    begin
      sbtnExplore.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnExplore.Height);
      sbtnExplore.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnExplore.Width);
      sbtnExplore.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnExplore.Left);
      sbtnExplore.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnExplore.Top);
      sbtnExplore.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnExplore.Visible);
      sbtnExplore.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnExplore.Font.Name);
      sbtnExplore.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnExplore.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnExplore.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnExplore.Font.Color))
      );

      sbtnExplore.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnExplore.Font.Style:=sbtnExplore.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnExplore.Font.Style:=sbtnExplore.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnExplore.Font.Style:=sbtnExplore.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnExplore.Font.Style:=sbtnExplore.Font.Style + [fsStrikeOut];
    end;

    // sbtnHelp
    strSection:='sbtnHelp';
    begin
      sbtnHelp.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnHelp.Height);
      sbtnHelp.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnHelp.Width);
      sbtnHelp.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnHelp.Left);
      sbtnHelp.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnHelp.Top);
      sbtnHelp.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnHelp.Visible);
      sbtnHelp.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnHelp.Font.Name);
      sbtnHelp.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnHelp.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnHelp.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnHelp.Font.Color))
      );

      sbtnHelp.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnHelp.Font.Style:=sbtnHelp.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnHelp.Font.Style:=sbtnHelp.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnHelp.Font.Style:=sbtnHelp.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnHelp.Font.Style:=sbtnHelp.Font.Style + [fsStrikeOut];
    end;

    // sbtnMusic
    strSection:='sbtnMusic';
    begin
      sbtnMusic.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnMusic.Height);
      sbtnMusic.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnMusic.Width);
      sbtnMusic.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnMusic.Left);
      sbtnMusic.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnMusic.Top);
      sbtnMusic.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnMusic.Visible);
      sbtnMusic.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnMusic.Font.Name);
      sbtnMusic.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnMusic.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnMusic.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnMusic.Font.Color))
      );

      sbtnMusic.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnMusic.Font.Style:=sbtnMusic.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnMusic.Font.Style:=sbtnMusic.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnMusic.Font.Style:=sbtnMusic.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnMusic.Font.Style:=sbtnMusic.Font.Style + [fsStrikeOut];
    end;

    // sbtnOptions
    strSection:='sbtnOptions';
    begin
      sbtnOptions.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnOptions.Height);
      sbtnOptions.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnOptions.Width);
      sbtnOptions.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnOptions.Left);
      sbtnOptions.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnOptions.Top);
      sbtnOptions.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnOptions.Visible);
      sbtnOptions.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnOptions.Font.Name);
      sbtnOptions.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnOptions.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnOptions.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnOptions.Font.Color))
      );

      sbtnOptions.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnOptions.Font.Style:=sbtnOptions.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnOptions.Font.Style:=sbtnOptions.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnOptions.Font.Style:=sbtnOptions.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnOptions.Font.Style:=sbtnOptions.Font.Style + [fsStrikeOut];
    end;

    // sbtnPictures
    strSection:='sbtnPictures';
    begin
      sbtnPictures.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnPictures.Height);
      sbtnPictures.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnPictures.Width);
      sbtnPictures.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnPictures.Left);
      sbtnPictures.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnPictures.Top);
      sbtnPictures.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnPictures.Visible);
      sbtnPictures.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnPictures.Font.Name);
      sbtnPictures.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnPictures.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnPictures.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnPictures.Font.Color))
      );

      sbtnPictures.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnPictures.Font.Style:=sbtnPictures.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnPictures.Font.Style:=sbtnPictures.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnPictures.Font.Style:=sbtnPictures.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnPictures.Font.Style:=sbtnPictures.Font.Style + [fsStrikeOut];
    end;

    // sbtnSearch
    strSection:='sbtnSearch';
    begin
      sbtnSearch.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnSearch.Height);
      sbtnSearch.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnSearch.Width);
      sbtnSearch.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnSearch.Left);
      sbtnSearch.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnSearch.Top);
      sbtnSearch.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnSearch.Visible);
      sbtnSearch.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnSearch.Font.Name);
      sbtnSearch.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnSearch.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnSearch.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnSearch.Font.Color))
      );

      sbtnSearch.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnSearch.Font.Style:=sbtnSearch.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnSearch.Font.Style:=sbtnSearch.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnSearch.Font.Style:=sbtnSearch.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnSearch.Font.Style:=sbtnSearch.Font.Style + [fsStrikeOut];
    end;

    // sbtnVideo
    strSection:='sbtnVideo';
    begin
      sbtnVideo.Height:=iniTheme.ReadInteger(strSection, 'Height', sbtnVideo.Height);
      sbtnVideo.Width:=iniTheme.ReadInteger(strSection, 'Width', sbtnVideo.Width);
      sbtnVideo.Left:=iniTheme.ReadInteger(strSection, 'Left', sbtnVideo.Left);
      sbtnVideo.Top:=iniTheme.ReadInteger(strSection, 'Top', sbtnVideo.Top);
      sbtnVideo.Visible:=iniTheme.ReadBool(strSection, 'Visible', sbtnVideo.Visible);
      sbtnVideo.Font.Name:=iniTheme.ReadString(strSection, 'Font', sbtnVideo.Font.Name);
      sbtnVideo.Font.Color:=RGB(
        iniTheme.ReadInteger(strSection, 'ColorR', GetRValue(sbtnVideo.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorG', GetGValue(sbtnVideo.Font.Color)),
        iniTheme.ReadInteger(strSection, 'ColorB', GetBValue(sbtnVideo.Font.Color))
      );

      sbtnVideo.Font.Style:=[];
      if iniTheme.ReadBool(strSection, 'Bold', True) then
        sbtnVideo.Font.Style:=sbtnVideo.Font.Style + [fsBold];
      if iniTheme.ReadBool(strSection, 'Italic', False) then
        sbtnVideo.Font.Style:=sbtnVideo.Font.Style + [fsItalic];
      if iniTheme.ReadBool(strSection, 'Underline', False) then
        sbtnVideo.Font.Style:=sbtnVideo.Font.Style + [fsUnderline];
      if iniTheme.ReadBool(strSection, 'StrikeOut', False) then
        sbtnVideo.Font.Style:=sbtnVideo.Font.Style + [fsStrikeOut];
    end;

    // Destroy the old images
    for intCounter := 0 to Length(imgarrCustomImages) - 1 do
      imgarrCustomImages[intCounter].Free;

    // Initialize our list of custom images
    strlstCustomImages:=TStringList.Create;
    // Load our custom image elements
    iniTheme.ReadSection('CustomImages', strlstCustomImages);
    SetLength(imgarrCustomImages, strlstCustomImages.Count);
    for intCounter := 0 to strlstCustomImages.Count - 1 do
    begin
      // Create a new image and set the strSection parameter
      imgarrCustomImages[intCounter] := TImage.Create(self);
      strSection := iniTheme.ReadString('CustomImages', strlstCustomImages.Strings[intCounter], '');
      with imgarrCustomImages[intCounter] do
      begin
        // Initialization stuff
        Parent := frmMenu;
        Name := 'dynimgCustomImage'+IntToStr(intCounter);
        // Visual settings
        Height := iniTheme.ReadInteger(strSection, 'Height', 0);
        Width := iniTheme.ReadInteger(strSection, 'Width', 0);
        Top := iniTheme.ReadInteger(strSection, 'Top', 0);
        Left := iniTheme.ReadInteger(strSection, 'Left', 0);
        Transparent := True;
        Stretch := True;
        // Picture (if it doesn't exist, throw an error and load the default theme)
        if FileExists(ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme+'/'+iniTheme.ReadString(strSection, 'Path', '')) then
          Picture.LoadFromFile(ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme+'/'+iniTheme.ReadString(strSection, 'Path', ''))
        else
        begin
          ShowMessageFmt(strSelectedThemeCorrupted, [strTheme]);
          strTheme:='Default';
          LoadTheme;
          exit;
        end;
        // OnClick handler - Assign a method with our onclick handler
        mtdOnClickMethod.Data := frmMenu;
        mtdOnClickMethod.Code := frmMenu.MethodAddress(iniTheme.ReadString(strSection, 'OnClick', ''));
        // If it was assigned, typecast it to a procedure and set OnClick to it
        if Assigned(mtdOnClickMethod.Code) then
          OnClick := TNotifyEvent(mtdOnClickMethod)
        else
        begin
          // Otherwise, look for a pathtoapp variable, parse it (thanks xrxca!) and assign the generic onclick handler
          Hint := StringReplace(StringReplace(StringReplace(iniTheme.ReadString(strSection, 'PathToApp', ''),
            '{DRIVE}', ExtractFileDrive(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]),
            '{APP}', ExtractFileDir(ExtractFileDir(ParamStr(0))), [rfReplaceAll, rfIgnoreCase]),
            '{THEME}', ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme, [rfReplaceAll, rfIgnoreCase]);
          OnClick := dynimgCustomImageClick;
        end;
      end;
    end;

    // Set '[imgPortableAppsLogoDebug]' settings
    strSection:='imgPortableAppsLogoDebug';
    bolForcePixel:=iniTheme.ReadBool(strSection, 'ForcePixel', False);
    bolForceAlpha:=iniTheme.ReadBool(strSection, 'ForceAlpha', False);

    // Load Header.bmp into imgPortableAppsLogoPixel and force display (if it exists)
    // NOTE: Located here instead of the initial image code because it overrides bolForcePixel.
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/header.bmp') then
    begin
      imgPortableAppsLogoPixel.Picture.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/header.bmp');
      bolForceAlpha:=False;
      bolForcePixel:=True;
    end
    else
      imgPortableAppsLogoPixel.Picture:=picOriginalLogo;

  // Show alpha logo for XP and pixel transparent logo for others
  if (Win32MajorVersion >= 5) and (Win32MinorVersion >= 1)
        AND (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    imgPortableAppsLogoPixel.Visible := false;
    imgPortableAppsLogo1.Visible := true;
    imgPortableAppsLogo2.Visible := true;
    imgPortableAppsLogo3.Visible := true;
    imgPortableAppsLogo4.Visible := true;
    imgPortableAppsLogo5.Visible := true;
    imgPortableAppsLogo6.Visible := true;
  end
  else begin
    imgPortableAppsLogoPixel.Visible := true;
    imgPortableAppsLogo1.Visible := false;
    imgPortableAppsLogo2.Visible := false;
    imgPortableAppsLogo3.Visible := false;
    imgPortableAppsLogo4.Visible := false;
    imgPortableAppsLogo5.Visible := false;
    imgPortableAppsLogo6.Visible := false;
  end;

  // Force a logo to display if a themer has set ForcePixel or ForceAlpha to true
  if bolForcePixel then
  begin
    imgPortableAppsLogoPixel.Visible := true;
    imgPortableAppsLogo1.Visible := false;
    imgPortableAppsLogo2.Visible := false;
    imgPortableAppsLogo3.Visible := false;
    imgPortableAppsLogo4.Visible := false;
    imgPortableAppsLogo5.Visible := false;
    imgPortableAppsLogo6.Visible := false;
  end;
  if bolForceAlpha then
  begin
    imgPortableAppsLogoPixel.Visible := false;
    imgPortableAppsLogo1.Visible := true;
    imgPortableAppsLogo2.Visible := true;
    imgPortableAppsLogo3.Visible := true;
    imgPortableAppsLogo4.Visible := true;
    imgPortableAppsLogo5.Visible := true;
    imgPortableAppsLogo6.Visible := true;
  end;

  // Close our INI file
  iniTheme.Free();

  // Update the button locations
  DisplayButtons();

  // Reload wallpaper
  if bolLoadWallpaper then
  begin
    pmnuitmOptionsLoadWallpaper.Enabled := True;
    // If we have a wallpaper specifically set for this theme, use it, else use the global one
    if FileExists(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp', '2', '0')
    else if FileExists(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp', '2', '0')
    // For compatability with the original wallpaper-swapper, look in DefaultData too
    else if FileExists(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp', '2', '0')
    else
    begin
      SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
    end;
  end;
  // Refresh theme position
  FadeInOut(true);
end;

// =====================================

procedure TfrmMenu.dynimgCustomImageClick(Sender: TObject);
// Handle a click event on a dynamic image by taking the app to execute from the path and executing it
begin
  if TImage(Sender).Hint <> '' then
    ShellExecute(0,'open', PAnsiChar(TImage(Sender).Hint),Nil, Nil, SW_SHOW);
end;

// =====================================

function TfrmMenu.OffsetToInt(strInteger : String; intDenominator : Integer) : Integer;
// Convert a string to an integer, even if it's a percentage value
begin
  if RightStr(strInteger, 1)='%' then
    result:=Round(intDenominator * (StrToInt(LeftStr(strInteger, Length(strInteger)-1)) / 100))
  else
    result:=StrToInt(strInteger);
end;

// =====================================

procedure TfrmMenu.OnFormMoving(var Msg: TWMMoving);
// Limit the screen position when dragging, and update offsets (XrXca)
var
  intMaxOffTop: Integer;
  rctMonitor: TRect;
begin
  intMaxOffTop := GetSystemMetrics(SM_CYCAPTION);
  // Keep it on the screen (for the most part)
  rctMonitor := Screen.MonitorFromPoint(msg.DragRect^.TopLeft).WorkareaRect;
  if msg.DragRect^.Right < rctMonitor.left + 75 then
    OffsetRect(msg.DragRect^, rctMonitor.Left + 75 - msg.DragRect^.Right, 0);
  if msg.DragRect^.Top < rctMonitor.top - intMaxOffTop  then
    OffsetRect(msg.DragRect^, 0, rctMonitor.Top - intMaxOffTop - msg.DragRect^.Top + 1);
  rctMonitor := Screen.MonitorFromPoint(msg.DragRect^.BottomRight).WorkareaRect;
  if msg.DragRect^.Left > rctMonitor.Right - 75 then
    OffsetRect(msg.DragRect^, rctMonitor.right - 75 - msg.DragRect^.Left, 0);
  if msg.DragRect^.Top > rctMonitor.Bottom - 75 then
    OffsetRect(msg.DragRect^, 0, rctMonitor.bottom - 75 - msg.DragRect^.Top);
  // Update OffsetX and OffsetY
  if bolSwitchSide then
  begin
    intOffsetX := msg.DragRect^.Left;
    intOffsetY := msg.DragRect^.Top;
  end
  else
  begin
    intOffsetX := msg.DragRect^.Right - Screen.WorkAreaRect.Right;
    intOffsetY := msg.DragRect^.Bottom - Screen.WorkAreaRect.Bottom;
  end;
end;

// =====================================

// ... and that's all folks... (aka app end)
end.
